!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 21

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(519)
  integer, parameter :: nGC_16 = 1
  integer, parameter :: nGC_1717 = 2
  integer, parameter :: nGC_1718 = 3
  integer, parameter :: nGC_18 = 4
  integer, parameter :: nGC_1719 = 5
  integer, parameter :: nGC_1720 = 6
  integer, parameter :: nGC_6 = 7
  integer, parameter :: nGC_1721 = 8
  integer, parameter :: nGC_1722 = 9
  integer, parameter :: nGC_15 = 10
  integer, parameter :: nGC_1723 = 11
  integer, parameter :: nGC_1724 = 12
  integer, parameter :: nGC_14 = 13
  integer, parameter :: nGC_1725 = 14
  integer, parameter :: nGC_1726 = 15
  integer, parameter :: nGC_3 = 16
  integer, parameter :: nGC_1727 = 17
  integer, parameter :: nGC_1728 = 18
  integer, parameter :: nGC_2 = 19
  integer, parameter :: nGC_12 = 20
  integer, parameter :: nGC_1730 = 21
  integer, parameter :: nGC_1731 = 22
  integer, parameter :: nGC_9 = 23
  integer, parameter :: nGC_10 = 24
  integer, parameter :: nGC_1735 = 25
  integer, parameter :: nGC_1736 = 26
  integer, parameter :: nGC_11 = 27
  integer, parameter :: nGC_1739 = 28
  integer, parameter :: nGC_1740 = 29
  integer, parameter :: nGC_4 = 30
  integer, parameter :: nGC_5 = 31
  integer, parameter :: nGC_1744 = 32
  integer, parameter :: nGC_1745 = 33
  integer, parameter :: nGC_13 = 34
  integer, parameter :: nGC_1746 = 35
  integer, parameter :: nGC_1747 = 36
  integer, parameter :: nGC_8 = 37
  integer, parameter :: nGC_1748 = 38
  integer, parameter :: nGC_1749 = 39
  integer, parameter :: nGC_1 = 40
  integer, parameter :: nGC_1750 = 41
  integer, parameter :: nGC_1751 = 42
  integer, parameter :: nGC_17 = 43
  integer, parameter :: nGC_7 = 44
  integer, parameter :: nGC_1753 = 45
  integer, parameter :: nGC_1754 = 46
  integer, parameter :: nGC_I = 47
  integer, parameter :: nGC_MI = 48
  integer, parameter :: nGC_47 = 49
  integer, parameter :: nGC_51 = 50
  integer, parameter :: nGC_53 = 51
  integer, parameter :: nGC_67 = 52
  integer, parameter :: nGC_71 = 53
  integer, parameter :: nGC_107 = 54
  integer, parameter :: nGC_115 = 55
  integer, parameter :: nGC_123 = 56
  integer, parameter :: nGC_209 = 57
  integer, parameter :: nGC_213 = 58
  integer, parameter :: nGC_225 = 59
  integer, parameter :: nGC_319 = 60
  integer, parameter :: nGC_385 = 61
  integer, parameter :: nGC_489 = 62
  integer, parameter :: nGC_501 = 63
  integer, parameter :: nGC_603 = 64
  integer, parameter :: nGC_2355 = 65
  integer, parameter :: nGC_2360 = 66
  integer, parameter :: nGC_2361 = 67
  integer, parameter :: nGC_2364 = 68
  integer, parameter :: nGC_2365 = 69
  integer, parameter :: nGC_2376 = 70
  integer, parameter :: nGC_2379 = 71
  integer, parameter :: nGC_2380 = 72
  integer, parameter :: nGC_2383 = 73
  integer, parameter :: nGC_2384 = 74
  integer, parameter :: nGC_2388 = 75
  integer, parameter :: nGC_2387 = 76
  integer, parameter :: nGC_2392 = 77
  integer, parameter :: nGC_2391 = 78
  integer, parameter :: nGC_2395 = 79
  integer, parameter :: nGC_2399 = 80
  integer, parameter :: nGC_2408 = 81
  integer, parameter :: nGC_2425 = 82
  integer, parameter :: nGC_2430 = 83
  integer, parameter :: nGC_2429 = 84
  integer, parameter :: nGC_2434 = 85
  integer, parameter :: nGC_2432 = 86
  integer, parameter :: nGC_2438 = 87
  integer, parameter :: nGC_2436 = 88
  integer, parameter :: nGC_2446 = 89
  integer, parameter :: nGC_2444 = 90
  integer, parameter :: nGC_2450 = 91
  integer, parameter :: nGC_2454 = 92
  integer, parameter :: nGC_2457 = 93
  integer, parameter :: nGC_2460 = 94
  integer, parameter :: nGC_2463 = 95
  integer, parameter :: nGC_2456 = 96
  integer, parameter :: nGC_2459 = 97
  integer, parameter :: nGC_2464 = 98
  integer, parameter :: nGC_2455 = 99
  integer, parameter :: nGC_2458 = 100
  integer, parameter :: nGC_2465 = 101
  integer, parameter :: nGC_2466 = 102
  integer, parameter :: nGC_2467 = 103
  integer, parameter :: nGC_2468 = 104
  integer, parameter :: nGC_2471 = 105
  integer, parameter :: nGC_2476 = 106
  integer, parameter :: nGC_2477 = 107
  integer, parameter :: nGC_2470 = 108
  integer, parameter :: nGC_2473 = 109
  integer, parameter :: nGC_2478 = 110
  integer, parameter :: nGC_2469 = 111
  integer, parameter :: nGC_2472 = 112
  integer, parameter :: nGC_2479 = 113
  integer, parameter :: nGC_2481 = 114
  integer, parameter :: nGC_2484 = 115
  integer, parameter :: nGC_2488 = 116
  integer, parameter :: nGC_2482 = 117
  integer, parameter :: nGC_2485 = 118
  integer, parameter :: nGC_2489 = 119
  integer, parameter :: nGC_2480 = 120
  integer, parameter :: nGC_2483 = 121
  integer, parameter :: nGC_2490 = 122
  integer, parameter :: nGC_2491 = 123
  integer, parameter :: nGC_2493 = 124
  integer, parameter :: nGC_2492 = 125
  integer, parameter :: nGC_2494 = 126
  integer, parameter :: nGC_2500 = 127
  integer, parameter :: nGC_2502 = 128
  integer, parameter :: nGC_2501 = 129
  integer, parameter :: nGC_2508 = 130
  integer, parameter :: nGC_2507 = 131
  integer, parameter :: nGC_2509 = 132
  integer, parameter :: nGC_2514 = 133
  integer, parameter :: nGC_2517 = 134
  integer, parameter :: nGC_2522 = 135
  integer, parameter :: nGC_2523 = 136
  integer, parameter :: nGC_2516 = 137
  integer, parameter :: nGC_2519 = 138
  integer, parameter :: nGC_2524 = 139
  integer, parameter :: nGC_2515 = 140
  integer, parameter :: nGC_2518 = 141
  integer, parameter :: nGC_2525 = 142
  integer, parameter :: nGC_2527 = 143
  integer, parameter :: nGC_2530 = 144
  integer, parameter :: nGC_2534 = 145
  integer, parameter :: nGC_2526 = 146
  integer, parameter :: nGC_2529 = 147
  integer, parameter :: nGC_2535 = 148
  integer, parameter :: nGC_2536 = 149
  integer, parameter :: nGC_2528 = 150
  integer, parameter :: nGC_2531 = 151
  integer, parameter :: nGC_2537 = 152
  integer, parameter :: nGC_2538 = 153
  integer, parameter :: nGC_2541 = 154
  integer, parameter :: nGC_2546 = 155
  integer, parameter :: nGC_2547 = 156
  integer, parameter :: nGC_2540 = 157
  integer, parameter :: nGC_2543 = 158
  integer, parameter :: nGC_2548 = 159
  integer, parameter :: nGC_2539 = 160
  integer, parameter :: nGC_2542 = 161
  integer, parameter :: nGC_2549 = 162
  integer, parameter :: nGC_2552 = 163
  integer, parameter :: nGC_2556 = 164
  integer, parameter :: nGC_2560 = 165
  integer, parameter :: nGC_2562 = 166
  integer, parameter :: nGC_2565 = 167
  integer, parameter :: nGC_2564 = 168
  integer, parameter :: nGC_2567 = 169
  integer, parameter :: nGC_2563 = 170
  integer, parameter :: nGC_2566 = 171
  integer, parameter :: nGC_2582 = 172
  integer, parameter :: nGC_2585 = 173
  integer, parameter :: nGC_2581 = 174
  integer, parameter :: nGC_2584 = 175
  integer, parameter :: nGC_2583 = 176
  integer, parameter :: nGC_2586 = 177
  integer, parameter :: nGC_2601 = 178
  integer, parameter :: nGC_2604 = 179
  integer, parameter :: nGC_2599 = 180
  integer, parameter :: nGC_2602 = 181
  integer, parameter :: nGC_2600 = 182
  integer, parameter :: nGC_2603 = 183
  integer, parameter :: nGC_2618 = 184
  integer, parameter :: nGC_2621 = 185
  integer, parameter :: nGC_2619 = 186
  integer, parameter :: nGC_2622 = 187
  integer, parameter :: nGC_2617 = 188
  integer, parameter :: nGC_2620 = 189
  integer, parameter :: nGC_2635 = 190
  integer, parameter :: nGC_2638 = 191
  integer, parameter :: nGC_2636 = 192
  integer, parameter :: nGC_2639 = 193
  integer, parameter :: nGC_2637 = 194
  integer, parameter :: nGC_2640 = 195
  integer, parameter :: nGC_2655 = 196
  integer, parameter :: nGC_2658 = 197
  integer, parameter :: nGC_2653 = 198
  integer, parameter :: nGC_2656 = 199
  integer, parameter :: nGC_2654 = 200
  integer, parameter :: nGC_2657 = 201
  integer, parameter :: nGC_2673 = 202
  integer, parameter :: nGC_2674 = 203
  integer, parameter :: nGC_2678 = 204
  integer, parameter :: nGC_2679 = 205
  integer, parameter :: nGC_2684 = 206
  integer, parameter :: nGC_2683 = 207
  integer, parameter :: nGC_2688 = 208
  integer, parameter :: nGC_2692 = 209
  integer, parameter :: nGC_2696 = 210
  integer, parameter :: nGC_2701 = 211
  integer, parameter :: nGC_2700 = 212
  integer, parameter :: nGC_2705 = 213
  integer, parameter :: nGC_2706 = 214
  integer, parameter :: nGC_2710 = 215
  integer, parameter :: nGC_2711 = 216
  integer, parameter :: nGC_2715 = 217
  integer, parameter :: nGC_2719 = 218
  integer, parameter :: nGC_2723 = 219
  integer, parameter :: nGC_2729 = 220
  integer, parameter :: nGC_2727 = 221
  integer, parameter :: nGC_2728 = 222
  integer, parameter :: nGC_2734 = 223
  integer, parameter :: nGC_2732 = 224
  integer, parameter :: nGC_2733 = 225
  integer, parameter :: nGC_2739 = 226
  integer, parameter :: nGC_2738 = 227
  integer, parameter :: nGC_2737 = 228
  integer, parameter :: nGC_2743 = 229
  integer, parameter :: nGC_2742 = 230
  integer, parameter :: nGC_2747 = 231
  integer, parameter :: nGC_2746 = 232
  integer, parameter :: nGC_2751 = 233
  integer, parameter :: nGC_2750 = 234
  integer, parameter :: nGC_2775 = 235
  integer, parameter :: nGC_2776 = 236
  integer, parameter :: nGC_2779 = 237
  integer, parameter :: nGC_2780 = 238
  integer, parameter :: nGC_2785 = 239
  integer, parameter :: nGC_2786 = 240
  integer, parameter :: nGC_2791 = 241
  integer, parameter :: nGC_2792 = 242
  integer, parameter :: nGC_2795 = 243
  integer, parameter :: nGC_2796 = 244
  integer, parameter :: nGC_2799 = 245
  integer, parameter :: nGC_2800 = 246
  integer, parameter :: nGC_2801 = 247
  integer, parameter :: nGC_2802 = 248
  integer, parameter :: nGC_2803 = 249
  integer, parameter :: nGC_2804 = 250
  integer, parameter :: nGC_2805 = 251
  integer, parameter :: nGC_2806 = 252
  integer, parameter :: nGC_2808 = 253
  integer, parameter :: nGC_2807 = 254
  integer, parameter :: nGC_2810 = 255
  integer, parameter :: nGC_2809 = 256
  integer, parameter :: nGC_2811 = 257
  integer, parameter :: nGC_2813 = 258
  integer, parameter :: nGC_2812 = 259
  integer, parameter :: nGC_2814 = 260
  integer, parameter :: nGC_2815 = 261
  integer, parameter :: nGC_2817 = 262
  integer, parameter :: nGC_2816 = 263
  integer, parameter :: nGC_2818 = 264
  integer, parameter :: nGC_2821 = 265
  integer, parameter :: nGC_2819 = 266
  integer, parameter :: nGC_2822 = 267
  integer, parameter :: nGC_2820 = 268
  integer, parameter :: nGC_2823 = 269
  integer, parameter :: nGC_2826 = 270
  integer, parameter :: nGC_2829 = 271
  integer, parameter :: nGC_2824 = 272
  integer, parameter :: nGC_2827 = 273
  integer, parameter :: nGC_2825 = 274
  integer, parameter :: nGC_2828 = 275
  integer, parameter :: nGC_2830 = 276
  integer, parameter :: nGC_2833 = 277
  integer, parameter :: nGC_2832 = 278
  integer, parameter :: nGC_2835 = 279
  integer, parameter :: nGC_2831 = 280
  integer, parameter :: nGC_2834 = 281
  integer, parameter :: nGC_2837 = 282
  integer, parameter :: nGC_2840 = 283
  integer, parameter :: nGC_2838 = 284
  integer, parameter :: nGC_2841 = 285
  integer, parameter :: nGC_2836 = 286
  integer, parameter :: nGC_2839 = 287
  integer, parameter :: nGC_2844 = 288
  integer, parameter :: nGC_2847 = 289
  integer, parameter :: nGC_2843 = 290
  integer, parameter :: nGC_2846 = 291
  integer, parameter :: nGC_2842 = 292
  integer, parameter :: nGC_2845 = 293
  integer, parameter :: nGC_2850 = 294
  integer, parameter :: nGC_2853 = 295
  integer, parameter :: nGC_2849 = 296
  integer, parameter :: nGC_2852 = 297
  integer, parameter :: nGC_2848 = 298
  integer, parameter :: nGC_2851 = 299
  integer, parameter :: nGC_2854 = 300
  integer, parameter :: nGC_2855 = 301
  integer, parameter :: nGC_2856 = 302
  integer, parameter :: nGC_2857 = 303
  integer, parameter :: nGC_2858 = 304
  integer, parameter :: nGC_2859 = 305
  integer, parameter :: nGC_2860 = 306
  integer, parameter :: nGC_2861 = 307
  integer, parameter :: nGC_2867 = 308
  integer, parameter :: nGC_2976 = 309
  integer, parameter :: nGC_2993 = 310
  integer, parameter :: nGC_3102 = 311
  integer, parameter :: nGC_3306 = 312
  integer, parameter :: nGC_3322 = 313
  integer, parameter :: nGC_3323 = 314
  integer, parameter :: nGC_3494 = 315
  integer, parameter :: nGC_3495 = 316
  integer, parameter :: nGC_1591 = 317
  integer, parameter :: nGC_1592 = 318
  integer, parameter :: nGC_1593 = 319
  integer, parameter :: nGC_1594 = 320
  integer, parameter :: nGC_1595 = 321
  integer, parameter :: nGC_1596 = 322
  integer, parameter :: nGC_1597 = 323
  integer, parameter :: nGC_1598 = 324
  integer, parameter :: nGC_1599 = 325
  integer, parameter :: nGC_1600 = 326
  integer, parameter :: nGC_1601 = 327
  integer, parameter :: nGC_1602 = 328
  integer, parameter :: nGC_1603 = 329
  integer, parameter :: nGC_1604 = 330
  integer, parameter :: nGC_1606 = 331
  integer, parameter :: nGC_1605 = 332
  integer, parameter :: nGC_1607 = 333
  integer, parameter :: nGC_1608 = 334
  integer, parameter :: nGC_1609 = 335
  integer, parameter :: nGC_1610 = 336
  integer, parameter :: nGC_1611 = 337
  integer, parameter :: nGC_1612 = 338
  integer, parameter :: nGC_5141 = 339
  integer, parameter :: nGC_1613 = 340
  integer, parameter :: nGC_5142 = 341
  integer, parameter :: nGC_1614 = 342
  integer, parameter :: nGC_1617 = 343
  integer, parameter :: nGC_1615 = 344
  integer, parameter :: nGC_1616 = 345
  integer, parameter :: nGC_1618 = 346
  integer, parameter :: nGC_1620 = 347
  integer, parameter :: nGC_1621 = 348
  integer, parameter :: nGC_1619 = 349
  integer, parameter :: nGC_1622 = 350
  integer, parameter :: nGC_5215 = 351
  integer, parameter :: nGC_1623 = 352
  integer, parameter :: nGC_1625 = 353
  integer, parameter :: nGC_1624 = 354
  integer, parameter :: nGC_1626 = 355
  integer, parameter :: nGC_1627 = 356
  integer, parameter :: nGC_5360 = 357
  integer, parameter :: nGC_1628 = 358
  integer, parameter :: nGC_5361 = 359
  integer, parameter :: nGC_1629 = 360
  integer, parameter :: nGC_1630 = 361
  integer, parameter :: nGC_5454 = 362
  integer, parameter :: nGC_5455 = 363
  integer, parameter :: nGC_1631 = 364
  integer, parameter :: nGC_5466 = 365
  integer, parameter :: nGC_1632 = 366
  integer, parameter :: nGC_5467 = 367
  integer, parameter :: nGC_1633 = 368
  integer, parameter :: nGC_5480 = 369
  integer, parameter :: nGC_1634 = 370
  integer, parameter :: nGC_5481 = 371
  integer, parameter :: nGC_1635 = 372
  integer, parameter :: nGC_1636 = 373
  integer, parameter :: nGC_1637 = 374
  integer, parameter :: nGC_1638 = 375
  integer, parameter :: nGC_1639 = 376
  integer, parameter :: nGC_5524 = 377
  integer, parameter :: nGC_1640 = 378
  integer, parameter :: nGC_1641 = 379
  integer, parameter :: nGC_1642 = 380
  integer, parameter :: nGC_1643 = 381
  integer, parameter :: nGC_1644 = 382
  integer, parameter :: nGC_1645 = 383
  integer, parameter :: nGC_1646 = 384
  integer, parameter :: nGC_1647 = 385
  integer, parameter :: nGC_1648 = 386
  integer, parameter :: nGC_1649 = 387
  integer, parameter :: nGC_1650 = 388
  integer, parameter :: nGC_1651 = 389
  integer, parameter :: nGC_1653 = 390
  integer, parameter :: nGC_1652 = 391
  integer, parameter :: nGC_1654 = 392
  integer, parameter :: nGC_1655 = 393
  integer, parameter :: nGC_1657 = 394
  integer, parameter :: nGC_1656 = 395
  integer, parameter :: nGC_1659 = 396
  integer, parameter :: nGC_1658 = 397
  integer, parameter :: nGC_1661 = 398
  integer, parameter :: nGC_1660 = 399
  integer, parameter :: nGC_1662 = 400
  integer, parameter :: nGC_1663 = 401
  integer, parameter :: nGC_1664 = 402
  integer, parameter :: nGC_6148 = 403
  integer, parameter :: nGC_1665 = 404
  integer, parameter :: nGC_6150 = 405
  integer, parameter :: nGC_1666 = 406
  integer, parameter :: nGC_1667 = 407
  integer, parameter :: nGC_1668 = 408
  integer, parameter :: nGC_1669 = 409
  integer, parameter :: nGC_1670 = 410
  integer, parameter :: nGC_1671 = 411
  integer, parameter :: nGC_1672 = 412
  integer, parameter :: nGC_1673 = 413
  integer, parameter :: nGC_1674 = 414
  integer, parameter :: nGC_1675 = 415
  integer, parameter :: nGC_1676 = 416
  integer, parameter :: nGC_1677 = 417
  integer, parameter :: nGC_1678 = 418
  integer, parameter :: nGC_1679 = 419
  integer, parameter :: nGC_1680 = 420
  integer, parameter :: nGC_1681 = 421
  integer, parameter :: nGC_1682 = 422
  integer, parameter :: nGC_1683 = 423
  integer, parameter :: nGC_1684 = 424
  integer, parameter :: nGC_1685 = 425
  integer, parameter :: nGC_1686 = 426
  integer, parameter :: nGC_1687 = 427
  integer, parameter :: nGC_1688 = 428
  integer, parameter :: nGC_1689 = 429
  integer, parameter :: nGC_1690 = 430
  integer, parameter :: nGC_1691 = 431
  integer, parameter :: nGC_1692 = 432
  integer, parameter :: nGC_1693 = 433
  integer, parameter :: nGC_1694 = 434
  integer, parameter :: nGC_1695 = 435
  integer, parameter :: nGC_1696 = 436
  integer, parameter :: nGC_1697 = 437
  integer, parameter :: nGC_1698 = 438
  integer, parameter :: nGC_1699 = 439
  integer, parameter :: nGC_1700 = 440
  integer, parameter :: nGC_1701 = 441
  integer, parameter :: nGC_1702 = 442
  integer, parameter :: nGC_1703 = 443
  integer, parameter :: nGC_1704 = 444
  integer, parameter :: nGC_1705 = 445
  integer, parameter :: nGC_1706 = 446
  integer, parameter :: nGC_1707 = 447
  integer, parameter :: nGC_1708 = 448
  integer, parameter :: nGC_1709 = 449
  integer, parameter :: nGC_1710 = 450
  integer, parameter :: nGC_1711 = 451
  integer, parameter :: nGC_1712 = 452
  integer, parameter :: nGC_1713 = 453
  integer, parameter :: nGC_1714 = 454
  integer, parameter :: nGC_1715 = 455
  integer, parameter :: nGC_1716 = 456
  integer, parameter :: nGC_21 = 457
  integer, parameter :: nGC_29 = 458
  integer, parameter :: nGC_33 = 459
  integer, parameter :: nGC_25 = 460
  integer, parameter :: nGC_1732 = 461
  integer, parameter :: nGC_1733 = 462
  integer, parameter :: nGC_1737 = 463
  integer, parameter :: nGC_1738 = 464
  integer, parameter :: nGC_1741 = 465
  integer, parameter :: nGC_1742 = 466
  integer, parameter :: nGC_1729 = 467
  integer, parameter :: nGC_1734 = 468
  integer, parameter :: nGC_1743 = 469
  integer, parameter :: nGC_1752 = 470
  integer, parameter :: nGC_2396 = 471
  integer, parameter :: nGC_2400 = 472
  integer, parameter :: nGC_2405 = 473
  integer, parameter :: nGC_2406 = 474
  integer, parameter :: nGC_2410 = 475
  integer, parameter :: nGC_2415 = 476
  integer, parameter :: nGC_2416 = 477
  integer, parameter :: nGC_2421 = 478
  integer, parameter :: nGC_2422 = 479
  integer, parameter :: nGC_2426 = 480
  integer, parameter :: nGC_2497 = 481
  integer, parameter :: nGC_2498 = 482
  integer, parameter :: nGC_2499 = 483
  integer, parameter :: nGC_2505 = 484
  integer, parameter :: nGC_2506 = 485
  integer, parameter :: nGC_2512 = 486
  integer, parameter :: nGC_2513 = 487
  integer, parameter :: nGC_2553 = 488
  integer, parameter :: nGC_2557 = 489
  integer, parameter :: nGC_2561 = 490
  integer, parameter :: nGC_2570 = 491
  integer, parameter :: nGC_2571 = 492
  integer, parameter :: nGC_2572 = 493
  integer, parameter :: nGC_2589 = 494
  integer, parameter :: nGC_2590 = 495
  integer, parameter :: nGC_2607 = 496
  integer, parameter :: nGC_2608 = 497
  integer, parameter :: nGC_2625 = 498
  integer, parameter :: nGC_2626 = 499
  integer, parameter :: nGC_2643 = 500
  integer, parameter :: nGC_2644 = 501
  integer, parameter :: nGC_2661 = 502
  integer, parameter :: nGC_2662 = 503
  integer, parameter :: nGC_2675 = 504
  integer, parameter :: nGC_2680 = 505
  integer, parameter :: nGC_2685 = 506
  integer, parameter :: nGC_2689 = 507
  integer, parameter :: nGC_2693 = 508
  integer, parameter :: nGC_2697 = 509
  integer, parameter :: nGC_2702 = 510
  integer, parameter :: nGC_2707 = 511
  integer, parameter :: nGC_2712 = 512
  integer, parameter :: nGC_2716 = 513
  integer, parameter :: nGC_2720 = 514
  integer, parameter :: nGC_2724 = 515
  integer, parameter :: nGC_2975 = 516
  integer, parameter :: nGC_2992 = 517
  integer, parameter :: nGC_3101 = 518
  integer, parameter :: nGC_3305 = 519
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
