!******************************************************************************!
!                                                                              !
!    class_ctparameters.f90                                                    !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_ctparameters.f90                         |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_ctparameters
  use constants_mdl, only: dp
  implicit none
  logical :: complex_mass_scheme=.true.
  complex(dp) :: dZeMinusR_GC12
  integer :: dZeMinusR_GC12_scheme = 0
  complex(dp) :: dZeMinusL_GC12
  integer :: dZeMinusL_GC12_scheme = 0
  complex(dp) :: dZeMinusL_GC22
  integer :: dZeMinusL_GC22_scheme = 0
  complex(dp) :: dZmuMinusR_GC12
  integer :: dZmuMinusR_GC12_scheme = 0
  complex(dp) :: dZmuMinusL_GC22
  integer :: dZmuMinusL_GC22_scheme = 0
  complex(dp) :: dZmuMinusL_GC12
  integer :: dZmuMinusL_GC12_scheme = 0
  complex(dp) :: dZtauMinusL_GC12
  integer :: dZtauMinusL_GC12_scheme = 0
  complex(dp) :: dZtauMinusL_GC22
  integer :: dZtauMinusL_GC22_scheme = 0
  complex(dp) :: dZtauMinusR_GC12
  integer :: dZtauMinusR_GC12_scheme = 0
  complex(dp) :: dZnu_eL_GC22
  integer :: dZnu_eL_GC22_scheme = 0
  complex(dp) :: dZnu_eL_GC12
  integer :: dZnu_eL_GC12_scheme = 0
  complex(dp) :: dZnu_muL_GC12
  integer :: dZnu_muL_GC12_scheme = 0
  complex(dp) :: dZnu_muL_GC22
  integer :: dZnu_muL_GC22_scheme = 0
  complex(dp) :: dZnu_tauL_GC12
  integer :: dZnu_tauL_GC12_scheme = 0
  complex(dp) :: dZnu_tauL_GC22
  integer :: dZnu_tauL_GC22_scheme = 0
  complex(dp) :: dZW3_GC22
  integer :: dZW3_GC22_scheme = 0
  complex(dp) :: dZB0_GC12
  integer :: dZB0_GC12_scheme = 0
  complex(dp) :: dZWMinus_GC22
  integer :: dZWMinus_GC22_scheme = 0
  complex(dp) :: dZPhi1_GC12
  integer :: dZPhi1_GC12_scheme = 0
  complex(dp) :: dZPhi1_GC22
  integer :: dZPhi1_GC22_scheme = 0
  complex(dp) :: dZPhi2_GC12
  integer :: dZPhi2_GC12_scheme = 0
  complex(dp) :: dZPhi2_GC22
  integer :: dZPhi2_GC22_scheme = 0
  complex(dp) :: dZg_QCD2
  integer :: dZg_QCD2_scheme = 0
  complex(dp) :: dZuL_QCD2
  integer :: dZuL_QCD2_scheme = 0
  complex(dp) :: dZuL_GC22
  integer :: dZuL_GC22_scheme = 0
  complex(dp) :: dZuL_GC12
  integer :: dZuL_GC12_scheme = 0
  complex(dp) :: dZuR_QCD2
  integer :: dZuR_QCD2_scheme = 0
  complex(dp) :: dZuR_GC12
  integer :: dZuR_GC12_scheme = 0
  complex(dp) :: dZuR_GC22
  integer :: dZuR_GC22_scheme = 0
  complex(dp) :: dZdR_GC12
  integer :: dZdR_GC12_scheme = 0
  complex(dp) :: dZdR_GC22
  integer :: dZdR_GC22_scheme = 0
  complex(dp) :: dZdR_QCD2
  integer :: dZdR_QCD2_scheme = 0
  complex(dp) :: dZdL_GC22
  integer :: dZdL_GC22_scheme = 0
  complex(dp) :: dZdL_GC12
  integer :: dZdL_GC12_scheme = 0
  complex(dp) :: dZdL_QCD2
  integer :: dZdL_QCD2_scheme = 0
  complex(dp) :: dZcR_QCD2
  integer :: dZcR_QCD2_scheme = 0
  complex(dp) :: dZcR_GC22
  integer :: dZcR_GC22_scheme = 0
  complex(dp) :: dZcR_GC12
  integer :: dZcR_GC12_scheme = 0
  complex(dp) :: dZcL_QCD2
  integer :: dZcL_QCD2_scheme = 0
  complex(dp) :: dZcL_GC22
  integer :: dZcL_GC22_scheme = 0
  complex(dp) :: dZcL_GC12
  integer :: dZcL_GC12_scheme = 0
  complex(dp) :: dZsR_QCD2
  integer :: dZsR_QCD2_scheme = 0
  complex(dp) :: dZsR_GC12
  integer :: dZsR_GC12_scheme = 0
  complex(dp) :: dZsR_GC22
  integer :: dZsR_GC22_scheme = 0
  complex(dp) :: dZsL_GC22
  integer :: dZsL_GC22_scheme = 0
  complex(dp) :: dZsL_GC12
  integer :: dZsL_GC12_scheme = 0
  complex(dp) :: dZsL_QCD2
  integer :: dZsL_QCD2_scheme = 0
  complex(dp) :: dZbR_QCD2
  integer :: dZbR_QCD2_scheme = 0
  complex(dp) :: dZbR_GC22
  integer :: dZbR_GC22_scheme = 0
  complex(dp) :: dZbR_GC12
  integer :: dZbR_GC12_scheme = 0
  complex(dp) :: dZbL_GC22
  integer :: dZbL_GC22_scheme = 0
  complex(dp) :: dZbL_QCD2
  integer :: dZbL_QCD2_scheme = 0
  complex(dp) :: dZbL_GC12
  integer :: dZbL_GC12_scheme = 0
  complex(dp) :: dZtR_GC22
  integer :: dZtR_GC22_scheme = 0
  complex(dp) :: dZtR_GC12
  integer :: dZtR_GC12_scheme = 0
  complex(dp) :: dZtR_QCD2
  integer :: dZtR_QCD2_scheme = 0
  complex(dp) :: dZtL_GC12
  integer :: dZtL_GC12_scheme = 0
  complex(dp) :: dZtL_QCD2
  integer :: dZtL_QCD2_scheme = 0
  complex(dp) :: dZtL_GC22
  integer :: dZtL_GC22_scheme = 0
  complex(dp) :: dZeMinusL_MS_GC12
  integer :: dZeMinusL_MS_GC12_scheme = 0
  complex(dp) :: dZeMinusL_MS_GC22
  integer :: dZeMinusL_MS_GC22_scheme = 0
  complex(dp) :: dZeMinusR_MS_GC12
  integer :: dZeMinusR_MS_GC12_scheme = 0
  complex(dp) :: dZB0_MS_GC12
  integer :: dZB0_MS_GC12_scheme = 0
  complex(dp) :: dZg1_GC12
  integer :: dZg1_GC12_scheme = 0
  complex(dp) :: dZW3_MS_GC22
  integer :: dZW3_MS_GC22_scheme = 0
  complex(dp) :: dZg2_GC22
  integer :: dZg2_GC22_scheme = 0
  complex(dp) :: dZgs_QCD2
  integer :: dZgs_QCD2_scheme = 0
! Derived counterterm parameters
  complex(dp) :: dg1t_GC13
  contains
  subroutine set_complex_mass_scheme_mdl

    ! This subroutine (re-)enables the complex mass scheme (hep-ph/0505042)

    complex_mass_scheme = .true.

  end subroutine set_complex_mass_scheme_mdl

  subroutine set_on_shell_scheme_mdl

    ! This subroutine disables the complex mass scheme

    complex_mass_scheme = .false.

  end subroutine set_on_shell_scheme_mdl
end module class_ctparameters
