!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_2857) = -coupl(nGC_2856)
    coupl(nGC_2858) = coupl(nGC_MI)*dZW3_GC22
    coupl(nGC_2859) = -coupl(nGC_2858)
    coupl(nGC_2860) = coupl(nGC_MI)*dZg_QCD2
    coupl(nGC_2861) = -coupl(nGC_2860)
    coupl(nGC_2867) = -coupl(nGC_2376)
    coupl(nGC_2976) = -coupl(nGC_2395)
    coupl(nGC_2993) = -coupl(nGC_2399)
    coupl(nGC_3102) = -coupl(nGC_2408)
    coupl(nGC_3306) = -coupl(nGC_2425)
    coupl(nGC_3322) = -coupl(nGC_2430)
    coupl(nGC_3323) = -coupl(nGC_2429)
    coupl(nGC_3494) = -coupl(nGC_2446)
    coupl(nGC_3495) = -coupl(nGC_2444)
    coupl(nGC_1591) = -cima*coupl(nGC_107)**2d0/(16d0*pi**2d0)
    coupl(nGC_1592) = -cima*coupl(nGC_1)**2d0/(16d0*pi**2d0)
    coupl(nGC_1593) = cima*(-coupl(nGC_4)**2d0 - coupl(nGC_9)**2d0)/(16d0*pi** &
                      2d0)
    coupl(nGC_1594) = cima*coupl(nGC_17)**2d0*sq2**2d0*(1d0 - Nc**2d0)/(64d0*pi&
                      **2d0*Nc)
    coupl(nGC_1595) = cima*(coupl(nGC_2)**2d0 + coupl(nGC_319)**2d0)/(192d0*pi &
                      **2d0)
    coupl(nGC_1596) = cima*(coupl(nGC_385)*coupl(nGC_8) + coupl(nGC_4)**2d0 +  &
                      coupl(nGC_489)**2d0 + coupl(nGC_603)*coupl(nGC_9))/(192d0&
                      *pi**2d0)
    coupl(nGC_1597) = cima*(coupl(nGC_385)*coupl(nGC_8) + coupl(nGC_5)**2d0 +  &
                      coupl(nGC_501)**2d0 + coupl(nGC_603)*coupl(nGC_9))/(192d0&
                      *pi**2d0)
    coupl(nGC_1598) = -cima*coupl(nGC_123)**2d0/(16d0*pi**2d0)
    coupl(nGC_1599) = cima*(-coupl(nGC_5)**2d0 - coupl(nGC_9)**2d0)/(16d0*pi** &
                      2d0)
    coupl(nGC_1600) = cima*(coupl(nGC_209)**2d0 + coupl(nGC_6)**2d0)/(48d0*pi**&
                      2d0)
    coupl(nGC_1601) = cima*(-2d0*Nc*coupl(nGC_9)**2d0 - coupl(nGC_209)**2d0 -  &
                      coupl(nGC_6)**2d0 - 2d0*coupl(nGC_9)**2d0)/(32d0*pi**2d0)
    coupl(nGC_1602) = cima*(-2d0*Nc*coupl(nGC_4)**2d0 - 2d0*Nc*coupl(nGC_5)**  &
                      2d0 - coupl(nGC_209)**2d0 - 2d0*coupl(nGC_4)**2d0 - 2d0* &
                      coupl(nGC_5)**2d0 - coupl(nGC_6)**2d0)/(32d0*pi**2d0)
    coupl(nGC_1603) = cima*(-2d0*Nc*coupl(nGC_1)**2d0 - Nc*coupl(nGC_107)**2d0 &
                       - Nc*coupl(nGC_123)**2d0 - coupl(nGC_115)**2d0 - 2d0*   &
                      coupl(nGC_2)**2d0)/(16d0*pi**2d0)
    coupl(nGC_1604) = cima*coupl(nGC_2)**2d0/(16d0*pi**2d0)
    coupl(nGC_1606) = cima*coupl(nGC_115)**2d0/(16d0*pi**2d0)
    coupl(nGC_1605) = cima*(coupl(nGC_4)**2d0 + coupl(nGC_9)**2d0)/(16d0*pi**  &
                      2d0)
    coupl(nGC_1607) = -cima*coupl(nGC_2)**2d0/(16d0*pi**2d0)
    coupl(nGC_1608) = -Nc*cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_1609) = cima*sq2**2d0*(Nc*coupl(nGC_16)**2d0 - 4d0*coupl(nGC_17  &
                      )**2d0)/(64d0*pi**2d0)
    coupl(nGC_1610) = cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_1611) = cima*sq2**2d0*(-Nc*coupl(nGC_16)**2d0 + 4d0*coupl(nGC_17 &
                      )**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_1612) = -coupl(nGC_2)*coupl(nGC_319)**2d0/(96d0*pi**2d0)
    coupl(nGC_5141) = -coupl(nGC_1612)
    coupl(nGC_1613) = coupl(nGC_2)*(-coupl(nGC_489)**2d0 - coupl(nGC_603)*coupl&
                      (nGC_9))/(96d0*pi**2d0)
    coupl(nGC_5142) = -coupl(nGC_1613)
    coupl(nGC_1614) = coupl(nGC_1)**3d0/(8d0*pi**2d0)
    coupl(nGC_1617) = coupl(nGC_107)**3d0/(8d0*pi**2d0)
    coupl(nGC_1615) = coupl(nGC_1)*(coupl(nGC_4)**2d0 + coupl(nGC_9)**2d0)/(8d0&
                      *pi**2d0)
    coupl(nGC_1616) = coupl(nGC_1)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1618) = coupl(nGC_107)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1620) = coupl(nGC_123)**3d0/(8d0*pi**2d0)
    coupl(nGC_1621) = coupl(nGC_123)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1619) = coupl(nGC_1)*(coupl(nGC_5)**2d0 + coupl(nGC_9)**2d0)/(8d0&
                      *pi**2d0)
    coupl(nGC_1622) = coupl(nGC_2)*(-coupl(nGC_501)**2d0 - coupl(nGC_603)*coupl&
                      (nGC_9))/(96d0*pi**2d0)
    coupl(nGC_5215) = -coupl(nGC_1622)
    coupl(nGC_1623) = coupl(nGC_2)**3d0/(8d0*pi**2d0)
    coupl(nGC_1625) = coupl(nGC_115)**3d0/(8d0*pi**2d0)
    coupl(nGC_1624) = coupl(nGC_2)*(coupl(nGC_4)**2d0 + coupl(nGC_9)**2d0)/(8d0&
                      *pi**2d0)
    coupl(nGC_1626) = coupl(nGC_2)*(coupl(nGC_5)**2d0 + coupl(nGC_9)**2d0)/(8d0&
                      *pi**2d0)
    coupl(nGC_1627) = -coupl(nGC_319)**2d0*coupl(nGC_4)/(96d0*pi**2d0)
    coupl(nGC_5360) = -coupl(nGC_1627)
    coupl(nGC_1628) = (6d0*coupl(nGC_209)*coupl(nGC_385)*coupl(nGC_8) - coupl( &
                      nGC_4)*coupl(nGC_489)**2d0 - coupl(nGC_5)*coupl(nGC_603)*&
                      coupl(nGC_9))/(96d0*pi**2d0)
    coupl(nGC_5361) = -coupl(nGC_1628)
    coupl(nGC_1629) = -coupl(nGC_319)**2d0*coupl(nGC_5)/(96d0*pi**2d0)
    coupl(nGC_1630) = (6d0*coupl(nGC_385)*coupl(nGC_6)*coupl(nGC_8) - coupl(   &
                      nGC_4)*coupl(nGC_603)*coupl(nGC_9) - coupl(nGC_5)*coupl( &
                      nGC_501)**2d0)/(96d0*pi**2d0)
    coupl(nGC_5454) = -coupl(nGC_1629)
    coupl(nGC_5455) = -coupl(nGC_1630)
    coupl(nGC_1631) = -coupl(nGC_319)**2d0*coupl(nGC_8)/(96d0*pi**2d0)
    coupl(nGC_5466) = -coupl(nGC_1631)
    coupl(nGC_1632) = coupl(nGC_8)*(6d0*coupl(nGC_209)*coupl(nGC_4) - coupl(   &
                      nGC_489)*coupl(nGC_501) + 6d0*coupl(nGC_5)*coupl(nGC_6   &
                      ))/(96d0*pi**2d0)
    coupl(nGC_5467) = -coupl(nGC_1632)
    coupl(nGC_1633) = -coupl(nGC_2)**2d0*coupl(nGC_9)/(96d0*pi**2d0)
    coupl(nGC_5480) = -coupl(nGC_1633)
    coupl(nGC_1634) = coupl(nGC_9)*(6d0*coupl(nGC_209)*coupl(nGC_501) - coupl( &
                      nGC_4)*coupl(nGC_5) + 6d0*coupl(nGC_489)*coupl(nGC_6))/( &
                      96d0*pi**2d0)
    coupl(nGC_5481) = -coupl(nGC_1634)
    coupl(nGC_1635) = coupl(nGC_1)**2d0*coupl(nGC_9)/(8d0*pi**2d0)
    coupl(nGC_1636) = coupl(nGC_9)*(coupl(nGC_209)*coupl(nGC_5) + coupl(nGC_4)*&
                      coupl(nGC_5) + coupl(nGC_4)*coupl(nGC_6))/(8d0*pi**2d0)
    coupl(nGC_1637) = coupl(nGC_17)**2d0*coupl(nGC_9)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1638) = coupl(nGC_2)**2d0*coupl(nGC_9)/(8d0*pi**2d0)
    coupl(nGC_1639) = (12d0*Nc*coupl(nGC_4)*coupl(nGC_9)**2d0 - 12d0*Nc*coupl( &
                      nGC_5)*coupl(nGC_9)**2d0 - 11d0*coupl(nGC_209)*coupl(    &
                      nGC_6)**2d0 + 12d0*coupl(nGC_4)*coupl(nGC_9)**2d0 - 12d0*&
                      coupl(nGC_5)*coupl(nGC_9)**2d0)/(96d0*pi**2d0)
    coupl(nGC_5524) = -coupl(nGC_1639)
    coupl(nGC_1640) = coupl(nGC_9)*(-coupl(nGC_209)*coupl(nGC_4) + coupl(nGC_4 &
                      )*coupl(nGC_5) - coupl(nGC_5)*coupl(nGC_6))/(8d0*pi**2d0)
    coupl(nGC_1641) = (coupl(nGC_4)**3d0 + coupl(nGC_5)*coupl(nGC_9)**2d0 +    &
                      coupl(nGC_6)*coupl(nGC_9)**2d0)/(8d0*pi**2d0)
    coupl(nGC_1642) = coupl(nGC_1)**2d0*coupl(nGC_4)/(8d0*pi**2d0)
    coupl(nGC_1643) = coupl(nGC_17)**2d0*coupl(nGC_4)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1644) = (coupl(nGC_209)*coupl(nGC_9)**2d0 + coupl(nGC_4)*coupl(  &
                      nGC_9)**2d0 + coupl(nGC_5)**3d0)/(8d0*pi**2d0)
    coupl(nGC_1645) = coupl(nGC_1)**2d0*coupl(nGC_5)/(8d0*pi**2d0)
    coupl(nGC_1646) = coupl(nGC_17)**2d0*coupl(nGC_5)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_1647) = (-coupl(nGC_209)*coupl(nGC_9)**2d0 + coupl(nGC_4)**3d0 + &
                      coupl(nGC_5)*coupl(nGC_9)**2d0)/(8d0*pi**2d0)
    coupl(nGC_1648) = coupl(nGC_2)**2d0*coupl(nGC_4)/(8d0*pi**2d0)
    coupl(nGC_1649) = coupl(nGC_2)**2d0*coupl(nGC_5)/(8d0*pi**2d0)
    coupl(nGC_1650) = -coupl(nGC_17)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(nGC_16  &
                      ) + coupl(nGC_17))/(64d0*pi**2d0*Nc)
    coupl(nGC_1651) = coupl(nGC_1)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0)
    coupl(nGC_1653) = coupl(nGC_107)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0)
    coupl(nGC_1652) = coupl(nGC_17)*sq2*(coupl(nGC_4)**2d0 + coupl(nGC_9)**2d0 &
                      )/(16d0*pi**2d0)
    coupl(nGC_1654) = -coupl(nGC_17)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(nGC_16 &
                      ) - coupl(nGC_17))/(64d0*pi**2d0*Nc**2d0)
    coupl(nGC_1655) = -coupl(nGC_1)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0*Nc)
    coupl(nGC_1657) = -coupl(nGC_107)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0*Nc)
    coupl(nGC_1656) = coupl(nGC_17)*sq2*(-coupl(nGC_4)**2d0 - coupl(nGC_9)**2d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_1659) = coupl(nGC_123)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0)
    coupl(nGC_1658) = coupl(nGC_17)*sq2*(coupl(nGC_5)**2d0 + coupl(nGC_9)**2d0 &
                      )/(16d0*pi**2d0)
    coupl(nGC_1661) = -coupl(nGC_123)**2d0*coupl(nGC_17)*sq2/(16d0*pi**2d0*Nc)
    coupl(nGC_1660) = coupl(nGC_17)*sq2*(-coupl(nGC_5)**2d0 - coupl(nGC_9)**2d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_1662) = coupl(nGC_17)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(nGC_16  &
                      ) - coupl(nGC_17))/(64d0*pi**2d0*Nc)
    coupl(nGC_1663) = coupl(nGC_17)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(nGC_16   &
                      ) + coupl(nGC_17))/(64d0*pi**2d0*Nc**2d0)
    coupl(nGC_1664) = sq2**3d0*(-11d0*Nc*cima*coupl(nGC_16)**3d0 - 48d0*coupl( &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_6148) = -coupl(nGC_1664)
    coupl(nGC_1665) = sq2**3d0*(11d0*Nc*cima*coupl(nGC_16)**3d0 + 48d0*coupl(  &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_6150) = -coupl(nGC_1665)
    coupl(nGC_1666) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_2)*coupl(nGC_4   &
                      ) + 3d0*coupl(nGC_10))/(96d0*pi**2d0)
    coupl(nGC_1667) = (4d0*cima*coupl(nGC_2)*coupl(nGC_4)*coupl(nGC_489)**2d0  &
                       + 4d0*cima*coupl(nGC_2)*coupl(nGC_5)*coupl(nGC_603)*    &
                      coupl(nGC_9) + 3d0*coupl(nGC_10)*coupl(nGC_489)**2d0 +   &
                      3d0*coupl(nGC_11)*coupl(nGC_603)*coupl(nGC_9) - 3d0*coupl&
                      (nGC_12)*coupl(nGC_209)*coupl(nGC_385) - 3d0*coupl(nGC_12&
                      )*coupl(nGC_6)*coupl(nGC_603))/(96d0*pi**2d0)
    coupl(nGC_1668) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_2)*coupl(nGC_8   &
                      ) + 3d0*coupl(nGC_12))/(96d0*pi**2d0)
    coupl(nGC_1669) = (4d0*cima*coupl(nGC_2)*coupl(nGC_489)*coupl(nGC_501)*    &
                      coupl(nGC_8) - 3d0*coupl(nGC_10)*coupl(nGC_209)*coupl(   &
                      nGC_8) - 3d0*coupl(nGC_11)*coupl(nGC_209)*coupl(nGC_603  &
                      ) + 3d0*coupl(nGC_12)*coupl(nGC_489)*coupl(nGC_501) - 3d0&
                      *coupl(nGC_12)*coupl(nGC_489)*coupl(nGC_6) - 3d0*coupl(  &
                      nGC_12)*coupl(nGC_5)*coupl(nGC_6))/(96d0*pi**2d0)
    coupl(nGC_1670) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_2)**2d0 + 3d0*   &
                      coupl(nGC_3))/(96d0*pi**2d0)
    coupl(nGC_1671) = (2d0*cima*coupl(nGC_2)**2d0*coupl(nGC_489)**2d0 + 2d0*   &
                      cima*coupl(nGC_2)**2d0*coupl(nGC_603)*coupl(nGC_9) + 2d0*&
                      cima*coupl(nGC_319)**2d0*coupl(nGC_385)*coupl(nGC_8) +   &
                      2d0*cima*coupl(nGC_319)**2d0*coupl(nGC_4)**2d0 + 3d0*    &
                      coupl(nGC_3)*coupl(nGC_489)**2d0 + 3d0*coupl(nGC_3)*coupl&
                      (nGC_603)*coupl(nGC_9))/(96d0*pi**2d0)
    coupl(nGC_1672) = (2d0*cima*coupl(nGC_2)**2d0*coupl(nGC_501)**2d0 + 2d0*   &
                      cima*coupl(nGC_2)**2d0*coupl(nGC_603)*coupl(nGC_9) + 2d0*&
                      cima*coupl(nGC_319)**2d0*coupl(nGC_385)*coupl(nGC_8) +   &
                      2d0*cima*coupl(nGC_319)**2d0*coupl(nGC_5)**2d0 + 3d0*    &
                      coupl(nGC_3)*coupl(nGC_501)**2d0 + 3d0*coupl(nGC_3)*coupl&
                      (nGC_603)*coupl(nGC_9))/(96d0*pi**2d0)
    coupl(nGC_1673) = coupl(nGC_2)**2d0*(4d0*cima*coupl(nGC_319)*coupl(nGC_9   &
                      ) + 3d0*coupl(nGC_12))/(96d0*pi**2d0)
    coupl(nGC_1674) = (4d0*cima*coupl(nGC_319)*coupl(nGC_4)*coupl(nGC_5)*coupl(&
                      nGC_9) - 3d0*coupl(nGC_10)*coupl(nGC_6)*coupl(nGC_9) -   &
                      3d0*coupl(nGC_11)*coupl(nGC_385)*coupl(nGC_6) - 3d0*coupl&
                      (nGC_12)*coupl(nGC_209)*coupl(nGC_4) - 3d0*coupl(nGC_12)*&
                      coupl(nGC_209)*coupl(nGC_501) + 3d0*coupl(nGC_12)*coupl( &
                      nGC_4)*coupl(nGC_5))/(96d0*pi**2d0)
    coupl(nGC_1675) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_2)*coupl(nGC_5   &
                      ) + 3d0*coupl(nGC_11))/(96d0*pi**2d0)
    coupl(nGC_1676) = (4d0*cima*coupl(nGC_2)*coupl(nGC_4)*coupl(nGC_603)*coupl(&
                      nGC_9) + 4d0*cima*coupl(nGC_2)*coupl(nGC_5)*coupl(nGC_501&
                      )**2d0 + 3d0*coupl(nGC_10)*coupl(nGC_603)*coupl(nGC_9) + &
                      3d0*coupl(nGC_11)*coupl(nGC_501)**2d0 - 3d0*coupl(nGC_12 &
                      )*coupl(nGC_209)*coupl(nGC_9) - 3d0*coupl(nGC_12)*coupl( &
                      nGC_6)*coupl(nGC_8))/(96d0*pi**2d0)
    coupl(nGC_1677) = (36d0*cima*coupl(nGC_13)**2d0 - 5d0*cima*coupl(nGC_385)**&
                      2d0*coupl(nGC_8)**2d0 - 5d0*cima*coupl(nGC_4)**4d0 - 10d0&
                      *cima*coupl(nGC_4)**2d0*coupl(nGC_489)**2d0 - 5d0*cima*  &
                      coupl(nGC_489)**4d0 - 5d0*cima*coupl(nGC_603)**2d0*coupl(&
                      nGC_9)**2d0 - 6d0*coupl(nGC_13)*coupl(nGC_385)*coupl(    &
                      nGC_8) - 6d0*coupl(nGC_13)*coupl(nGC_4)**2d0 - 6d0*coupl(&
                      nGC_13)*coupl(nGC_489)**2d0 - 6d0*coupl(nGC_13)*coupl(   &
                      nGC_603)*coupl(nGC_9))/(96d0*pi**2d0)
    coupl(nGC_1678) = (-5d0*cima*coupl(nGC_2)**4d0 - 10d0*cima*coupl(nGC_2)**  &
                      2d0*coupl(nGC_319)**2d0 + 12d0*cima*coupl(nGC_3)**2d0 -  &
                      5d0*cima*coupl(nGC_319)**4d0 - 6d0*coupl(nGC_2)**2d0*    &
                      coupl(nGC_3) - 6d0*coupl(nGC_3)*coupl(nGC_319)**2d0)/(   &
                      96d0*pi**2d0)
    coupl(nGC_1679) = (12d0*cima*coupl(nGC_10)**2d0 - 5d0*cima*coupl(nGC_2)**  &
                      2d0*coupl(nGC_4)**2d0 - 10d0*cima*coupl(nGC_2)*coupl(    &
                      nGC_319)*coupl(nGC_4)*coupl(nGC_489) - 5d0*cima*coupl(   &
                      nGC_319)**2d0*coupl(nGC_489)**2d0 - 6d0*coupl(nGC_10)*   &
                      coupl(nGC_2)*coupl(nGC_4) - 6d0*coupl(nGC_10)*coupl(     &
                      nGC_319)*coupl(nGC_489))/(48d0*pi**2d0)
    coupl(nGC_1680) = (-5d0*cima*coupl(nGC_2)**4d0 - 5d0*cima*coupl(nGC_2)**2d0&
                      *coupl(nGC_319)**2d0 + 6d0*cima*coupl(nGC_3)**2d0 - 6d0* &
                      coupl(nGC_2)**2d0*coupl(nGC_3))/(96d0*pi**2d0)
    coupl(nGC_1681) = (18d0*cima*coupl(nGC_13)**2d0 - 5d0*cima*coupl(nGC_385)* &
                      coupl(nGC_603)*coupl(nGC_8)*coupl(nGC_9) - 5d0*cima*coupl&
                      (nGC_4)**2d0*coupl(nGC_5)**2d0 - 5d0*cima*coupl(nGC_4)** &
                      2d0*coupl(nGC_501)**2d0 - 5d0*cima*coupl(nGC_4)*coupl(   &
                      nGC_501)*coupl(nGC_8)*coupl(nGC_9) - 5d0*cima*coupl(     &
                      nGC_489)**2d0*coupl(nGC_603)*coupl(nGC_9) - 5d0*cima*    &
                      coupl(nGC_489)*coupl(nGC_5)*coupl(nGC_8)*coupl(nGC_9) -  &
                      5d0*cima*coupl(nGC_501)**2d0*coupl(nGC_603)*coupl(nGC_9  &
                      ) - 6d0*coupl(nGC_13)*coupl(nGC_385)*coupl(nGC_8) - 3d0* &
                      coupl(nGC_13)*coupl(nGC_4)**2d0 - 3d0*coupl(nGC_13)*coupl&
                      (nGC_5)**2d0)/(96d0*pi**2d0)
    coupl(nGC_1682) = (6d0*cima*coupl(nGC_10)*coupl(nGC_11) + 6d0*cima*coupl(  &
                      nGC_12)**2d0 - 5d0*cima*coupl(nGC_2)**2d0*coupl(nGC_4)*  &
                      coupl(nGC_5) - 5d0*cima*coupl(nGC_2)*coupl(nGC_319)*coupl&
                      (nGC_4)*coupl(nGC_501) - 5d0*cima*coupl(nGC_2)*coupl(    &
                      nGC_319)*coupl(nGC_8)*coupl(nGC_9) - 5d0*cima*coupl(     &
                      nGC_319)**2d0*coupl(nGC_603)*coupl(nGC_9) - 3d0*coupl(   &
                      nGC_10)*coupl(nGC_2)*coupl(nGC_5) - 3d0*coupl(nGC_11)*   &
                      coupl(nGC_2)*coupl(nGC_4) - 3d0*coupl(nGC_12)*coupl(     &
                      nGC_319)*coupl(nGC_603) - 3d0*coupl(nGC_12)*coupl(nGC_319&
                      )*coupl(nGC_9))/(48d0*pi**2d0)
    coupl(nGC_1683) = (24d0*cima*coupl(nGC_13)*coupl(nGC_14) + 12d0*cima*coupl(&
                      nGC_13)*coupl(nGC_15) + 9d0*cima*coupl(nGC_209)**2d0*    &
                      coupl(nGC_4)**2d0 + 4d0*cima*coupl(nGC_385)*coupl(nGC_489&
                      )**2d0*coupl(nGC_8) + 9d0*cima*coupl(nGC_385)*coupl(nGC_6&
                      )**2d0*coupl(nGC_8) + 4d0*cima*coupl(nGC_385)*coupl(     &
                      nGC_603)*coupl(nGC_8)*coupl(nGC_9) + 9d0*cima*coupl(nGC_4&
                      )**2d0*coupl(nGC_6)**2d0 + 36d0*coupl(nGC_13)*coupl(     &
                      nGC_209)**2d0 - 12d0*coupl(nGC_13)*coupl(nGC_209)*coupl( &
                      nGC_4) - 12d0*coupl(nGC_13)*coupl(nGC_4)*coupl(nGC_6) +  &
                      6d0*coupl(nGC_13)*coupl(nGC_489)**2d0 + 36d0*coupl(nGC_13&
                      )*coupl(nGC_6)**2d0 + 6d0*coupl(nGC_13)*coupl(nGC_603)*  &
                      coupl(nGC_9) - 6d0*coupl(nGC_14)*coupl(nGC_385)*coupl(   &
                      nGC_8) - 6d0*coupl(nGC_15)*coupl(nGC_4)**2d0)/(192d0*pi**&
                      2d0)
    coupl(nGC_1684) = coupl(nGC_319)**2d0*(2d0*cima*coupl(nGC_385)*coupl(nGC_8 &
                      ) + 3d0*coupl(nGC_13))/(96d0*pi**2d0)
    coupl(nGC_1685) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_4)**2d0 + 3d0*   &
                      coupl(nGC_13))/(96d0*pi**2d0)
    coupl(nGC_1686) = (12d0*cima*coupl(nGC_13)*coupl(nGC_15) + 9d0*cima*coupl( &
                      nGC_209)**2d0*coupl(nGC_385)*coupl(nGC_8) + 4d0*cima*    &
                      coupl(nGC_4)**2d0*coupl(nGC_489)**2d0 + 4d0*cima*coupl(  &
                      nGC_5)**2d0*coupl(nGC_603)*coupl(nGC_9) + 18d0*coupl(    &
                      nGC_13)*coupl(nGC_209)**2d0 + 3d0*coupl(nGC_13)*coupl(   &
                      nGC_489)**2d0 + 18d0*coupl(nGC_13)*coupl(nGC_6)**2d0 +   &
                      3d0*coupl(nGC_13)*coupl(nGC_603)*coupl(nGC_9) - 3d0*coupl&
                      (nGC_15)*coupl(nGC_385)*coupl(nGC_8))/(96d0*pi**2d0)
    coupl(nGC_1687) = (36d0*cima*coupl(nGC_13)**2d0 - 5d0*cima*coupl(nGC_385)**&
                      2d0*coupl(nGC_8)**2d0 - 5d0*cima*coupl(nGC_5)**4d0 - 10d0&
                      *cima*coupl(nGC_5)**2d0*coupl(nGC_501)**2d0 - 5d0*cima*  &
                      coupl(nGC_501)**4d0 - 5d0*cima*coupl(nGC_603)**2d0*coupl(&
                      nGC_9)**2d0 - 6d0*coupl(nGC_13)*coupl(nGC_385)*coupl(    &
                      nGC_8) - 6d0*coupl(nGC_13)*coupl(nGC_5)**2d0 - 6d0*coupl(&
                      nGC_13)*coupl(nGC_501)**2d0 - 6d0*coupl(nGC_13)*coupl(   &
                      nGC_603)*coupl(nGC_9))/(96d0*pi**2d0)
    coupl(nGC_1688) = (12d0*cima*coupl(nGC_11)**2d0 - 5d0*cima*coupl(nGC_2)**  &
                      2d0*coupl(nGC_5)**2d0 - 10d0*cima*coupl(nGC_2)*coupl(    &
                      nGC_319)*coupl(nGC_5)*coupl(nGC_501) - 5d0*cima*coupl(   &
                      nGC_319)**2d0*coupl(nGC_501)**2d0 - 6d0*coupl(nGC_11)*   &
                      coupl(nGC_2)*coupl(nGC_5) - 6d0*coupl(nGC_11)*coupl(     &
                      nGC_319)*coupl(nGC_501))/(48d0*pi**2d0)
    coupl(nGC_1689) = cima*coupl(nGC_9)**2d0*(Nc*coupl(nGC_1)**2d0 + coupl(    &
                      nGC_2)**2d0)/(8d0*pi**2d0)
    coupl(nGC_1690) = (24d0*cima*coupl(nGC_13)*coupl(nGC_14) + 12d0*cima*coupl(&
                      nGC_13)*coupl(nGC_15) + 9d0*cima*coupl(nGC_209)**2d0*    &
                      coupl(nGC_385)*coupl(nGC_8) + 9d0*cima*coupl(nGC_209)**  &
                      2d0*coupl(nGC_5)**2d0 + 4d0*cima*coupl(nGC_385)*coupl(   &
                      nGC_501)**2d0*coupl(nGC_8) + 4d0*cima*coupl(nGC_385)*    &
                      coupl(nGC_603)*coupl(nGC_8)*coupl(nGC_9) + 9d0*cima*coupl&
                      (nGC_5)**2d0*coupl(nGC_6)**2d0 + 36d0*coupl(nGC_13)*coupl&
                      (nGC_209)**2d0 - 12d0*coupl(nGC_13)*coupl(nGC_209)*coupl(&
                      nGC_5) - 12d0*coupl(nGC_13)*coupl(nGC_5)*coupl(nGC_6) +  &
                      6d0*coupl(nGC_13)*coupl(nGC_501)**2d0 + 36d0*coupl(nGC_13&
                      )*coupl(nGC_6)**2d0 + 6d0*coupl(nGC_13)*coupl(nGC_603)*  &
                      coupl(nGC_9) - 6d0*coupl(nGC_14)*coupl(nGC_385)*coupl(   &
                      nGC_8) - 6d0*coupl(nGC_15)*coupl(nGC_5)**2d0)/(192d0*pi**&
                      2d0)
    coupl(nGC_1691) = coupl(nGC_319)**2d0*(4d0*cima*coupl(nGC_5)**2d0 + 3d0*   &
                      coupl(nGC_13))/(96d0*pi**2d0)
    coupl(nGC_1692) = (12d0*cima*coupl(nGC_13)*coupl(nGC_15) + 9d0*cima*coupl( &
                      nGC_385)*coupl(nGC_6)**2d0*coupl(nGC_8) + 4d0*cima*coupl(&
                      nGC_4)**2d0*coupl(nGC_603)*coupl(nGC_9) + 4d0*cima*coupl(&
                      nGC_5)**2d0*coupl(nGC_501)**2d0 + 18d0*coupl(nGC_13)*    &
                      coupl(nGC_209)**2d0 + 3d0*coupl(nGC_13)*coupl(nGC_501)** &
                      2d0 + 18d0*coupl(nGC_13)*coupl(nGC_6)**2d0 + 3d0*coupl(  &
                      nGC_13)*coupl(nGC_603)*coupl(nGC_9) - 3d0*coupl(nGC_15)* &
                      coupl(nGC_385)*coupl(nGC_8))/(96d0*pi**2d0)
    coupl(nGC_1693) = cima*(Nc*coupl(nGC_1)**2d0*coupl(nGC_4)**2d0 + Nc*coupl( &
                      nGC_1)**2d0*coupl(nGC_5)**2d0 + coupl(nGC_2)**2d0*coupl( &
                      nGC_4)**2d0 + coupl(nGC_2)**2d0*coupl(nGC_5)**2d0)/(8d0* &
                      pi**2d0)
    coupl(nGC_1694) = (-4d0*Nc*cima*coupl(nGC_4)**2d0*coupl(nGC_9)**2d0 + 12d0*&
                      Nc*cima*coupl(nGC_4)*coupl(nGC_5)*coupl(nGC_9)**2d0 - 4d0&
                      *Nc*cima*coupl(nGC_5)**2d0*coupl(nGC_9)**2d0 - 8d0*cima* &
                      coupl(nGC_209)**2d0*coupl(nGC_6)**2d0 - 4d0*cima*coupl(  &
                      nGC_4)**2d0*coupl(nGC_9)**2d0 + 12d0*cima*coupl(nGC_4)*  &
                      coupl(nGC_5)*coupl(nGC_9)**2d0 - 4d0*cima*coupl(nGC_5)** &
                      2d0*coupl(nGC_9)**2d0 + 4d0*cima*coupl(nGC_67)**2d0 +    &
                      coupl(nGC_14)*coupl(nGC_6)**2d0 + 2d0*coupl(nGC_15)*coupl&
                      (nGC_209)*coupl(nGC_6) + coupl(nGC_209)**2d0*coupl(nGC_71&
                      ) + 12d0*coupl(nGC_209)*coupl(nGC_6)*coupl(nGC_67) +     &
                      coupl(nGC_6)**2d0*coupl(nGC_67))/(32d0*pi**2d0)
    coupl(nGC_1695) = (-4d0*Nc*cima*coupl(nGC_4)**2d0*coupl(nGC_9)**2d0 + 12d0*&
                      Nc*cima*coupl(nGC_4)*coupl(nGC_5)*coupl(nGC_9)**2d0 - 4d0&
                      *Nc*cima*coupl(nGC_5)**2d0*coupl(nGC_9)**2d0 - 8d0*cima* &
                      coupl(nGC_209)**2d0*coupl(nGC_6)**2d0 - 4d0*cima*coupl(  &
                      nGC_4)**2d0*coupl(nGC_9)**2d0 + 12d0*cima*coupl(nGC_4)*  &
                      coupl(nGC_5)*coupl(nGC_9)**2d0 - 4d0*cima*coupl(nGC_5)** &
                      2d0*coupl(nGC_9)**2d0 + 4d0*cima*coupl(nGC_67)**2d0 +    &
                      coupl(nGC_14)*coupl(nGC_209)**2d0 + 2d0*coupl(nGC_15)*   &
                      coupl(nGC_209)*coupl(nGC_6) + 12d0*coupl(nGC_209)*coupl( &
                      nGC_6)*coupl(nGC_67) + coupl(nGC_6)**2d0*coupl(nGC_67) + &
                      coupl(nGC_6)**2d0*coupl(nGC_71))/(32d0*pi**2d0)
    coupl(nGC_1696) = (18d0*Nc*cima*coupl(nGC_4)**2d0*coupl(nGC_9)**2d0 - 30d0*&
                      Nc*cima*coupl(nGC_4)*coupl(nGC_5)*coupl(nGC_9)**2d0 +    &
                      18d0*Nc*cima*coupl(nGC_5)**2d0*coupl(nGC_9)**2d0 + 6d0*  &
                      cima*coupl(nGC_14)*coupl(nGC_15) - 16d0*cima*coupl(      &
                      nGC_209)**2d0*coupl(nGC_6)**2d0 + 18d0*cima*coupl(nGC_4  &
                      )**2d0*coupl(nGC_9)**2d0 - 30d0*cima*coupl(nGC_4)*coupl( &
                      nGC_5)*coupl(nGC_9)**2d0 + 18d0*cima*coupl(nGC_5)**2d0*  &
                      coupl(nGC_9)**2d0 + 9d0*coupl(nGC_14)*coupl(nGC_209)**2d0&
                       + 9d0*coupl(nGC_14)*coupl(nGC_6)**2d0 + 9d0*coupl(nGC_15&
                      )*coupl(nGC_6)**2d0 + 6d0*coupl(nGC_209)*coupl(nGC_6)*   &
                      coupl(nGC_67))/(48d0*pi**2d0)
    coupl(nGC_1697) = (36d0*Nc*cima*coupl(nGC_9)**4d0 + 12d0*cima*coupl(nGC_14 &
                      )**2d0 + 6d0*cima*coupl(nGC_15)**2d0 - 16d0*cima*coupl(  &
                      nGC_209)**4d0 - 24d0*cima*coupl(nGC_209)**2d0*coupl(nGC_6&
                      )**2d0 - 16d0*cima*coupl(nGC_6)**4d0 + 36d0*cima*coupl(  &
                      nGC_9)**4d0 + 21d0*coupl(nGC_14)*coupl(nGC_209)**2d0 +   &
                      6d0*coupl(nGC_14)*coupl(nGC_209)*coupl(nGC_6) + 21d0*    &
                      coupl(nGC_14)*coupl(nGC_6)**2d0 + 18d0*coupl(nGC_15)*    &
                      coupl(nGC_209)**2d0 + 18d0*coupl(nGC_15)*coupl(nGC_6)**  &
                      2d0 + 3d0*coupl(nGC_209)**2d0*coupl(nGC_67) + 3d0*coupl( &
                      nGC_6)**2d0*coupl(nGC_67))/(96d0*pi**2d0)
    coupl(nGC_1698) = (-30d0*Nc*cima*coupl(nGC_9)**4d0 - 4d0*cima*coupl(nGC_209&
                      )**4d0 - 16d0*cima*coupl(nGC_209)**2d0*coupl(nGC_6)**2d0 &
                       - 4d0*cima*coupl(nGC_6)**4d0 + 3d0*cima*coupl(nGC_71)** &
                      2d0 - 30d0*cima*coupl(nGC_9)**4d0 + 3d0*coupl(nGC_209)** &
                      2d0*coupl(nGC_67) + 3d0*coupl(nGC_209)**2d0*coupl(nGC_71 &
                      ) + 18d0*coupl(nGC_209)*coupl(nGC_6)*coupl(nGC_71) + 3d0*&
                      coupl(nGC_6)**2d0*coupl(nGC_67) + 3d0*coupl(nGC_6)**2d0* &
                      coupl(nGC_71))/(48d0*pi**2d0)
    coupl(nGC_1699) = cima*coupl(nGC_17)**2d0*coupl(nGC_9)**2d0*sq2**2d0/(32d0*&
                      pi**2d0)
    coupl(nGC_1700) = -cima*coupl(nGC_17)**2d0*coupl(nGC_9)**2d0*sq2**2d0/(32d0&
                      *pi**2d0*Nc)
    coupl(nGC_1701) = (3d0*Nc*cima*coupl(nGC_4)**4d0 + 3d0*Nc*cima*coupl(nGC_5 &
                      )**4d0 + 3d0*cima*coupl(nGC_15)**2d0 - 10d0*cima*coupl(  &
                      nGC_209)**4d0 + 3d0*cima*coupl(nGC_4)**4d0 + 3d0*cima*   &
                      coupl(nGC_5)**4d0 - 10d0*cima*coupl(nGC_6)**4d0 + 9d0*   &
                      coupl(nGC_15)*coupl(nGC_209)**2d0 + 9d0*coupl(nGC_15)*   &
                      coupl(nGC_6)**2d0 + 3d0*coupl(nGC_209)**2d0*coupl(nGC_67 &
                      ) + 3d0*coupl(nGC_6)**2d0*coupl(nGC_67))/(24d0*pi**2d0)
    coupl(nGC_1702) = cima*(2d0*Nc*coupl(nGC_1)**4d0 + Nc*coupl(nGC_107)**4d0  &
                       + Nc*coupl(nGC_123)**4d0 + coupl(nGC_115)**4d0 + 2d0*   &
                      coupl(nGC_2)**4d0)/(8d0*pi**2d0)
    coupl(nGC_1703) = cima*coupl(nGC_17)**2d0*sq2**2d0*(coupl(nGC_4)**2d0 +    &
                      coupl(nGC_5)**2d0)/(32d0*pi**2d0)
    coupl(nGC_1704) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_4)**2d0 -   &
                      coupl(nGC_5)**2d0)/(32d0*pi**2d0*Nc)
    coupl(nGC_1705) = cima*coupl(nGC_17)**2d0*sq2**2d0*(2d0*coupl(nGC_1)**2d0  &
                       + coupl(nGC_107)**2d0 + coupl(nGC_123)**2d0)/(32d0*pi** &
                      2d0)
    coupl(nGC_1706) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-2d0*coupl(nGC_1)**2d0 &
                       - coupl(nGC_107)**2d0 - coupl(nGC_123)**2d0)/(32d0*pi** &
                      2d0*Nc)
    coupl(nGC_1707) = cima*coupl(nGC_17)**3d0*sq2**3d0*(2d0*coupl(nGC_1) +     &
                      coupl(nGC_107) + coupl(nGC_123))/(128d0*pi**2d0)
    coupl(nGC_1708) = cima*coupl(nGC_17)**3d0*sq2**3d0*(-2d0*coupl(nGC_1) -    &
                      coupl(nGC_107) - coupl(nGC_123))/(64d0*pi**2d0*Nc)
    coupl(nGC_1709) = cima*coupl(nGC_17)**3d0*sq2**3d0*(2d0*coupl(nGC_1) +     &
                      coupl(nGC_107) + coupl(nGC_123))/(32d0*pi**2d0*Nc**2d0)
    coupl(nGC_1710) = sq2**2d0*(-Nc*cima*coupl(nGC_16)**4d0*sq2**2d0 + 3d0*Nc* &
                      coupl(nGC_16)**2d0*coupl(nGC_47) - 15d0*cima*coupl(nGC_17&
                      )**4d0*sq2**2d0)/(192d0*pi**2d0)
    coupl(nGC_1711) = (-4d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*Nc*cima*&
                      coupl(nGC_18)**2d0 + 21d0*Nc*coupl(nGC_16)**2d0*coupl(   &
                      nGC_18)*sq2**2d0 + 18d0*cima*coupl(nGC_17)**4d0*sq2**4d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_1712) = (10d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 12d0*Nc*cima*&
                      coupl(nGC_18)*coupl(nGC_51) - 21d0*Nc*coupl(nGC_16)**2d0*&
                      coupl(nGC_18)*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*coupl(&
                      nGC_47)*sq2**2d0 - 9d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_51&
                      )*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_53)*sq2 &
                      **2d0 - 6d0*cima*coupl(nGC_17)**4d0*sq2**4d0)/(384d0*pi**&
                      2d0*Nc)
    coupl(nGC_1713) = (-10d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 6d0*cima*coupl(&
                      nGC_51)**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**&
                      2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_47)*sq2**2d0 +    &
                      18d0*coupl(nGC_16)**2d0*coupl(nGC_51)*sq2**2d0 + 3d0*    &
                      coupl(nGC_16)**2d0*coupl(nGC_53)*sq2**2d0)/(192d0*pi**2d0&
                      )
    coupl(nGC_1714) = (-5d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*cima*coupl(&
                      nGC_18)**2d0 + 18d0*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2 &
                      **2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_53)*sq2**2d0)/( &
                      96d0*pi**2d0)
    coupl(nGC_1715) = cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc**2d0)
    coupl(nGC_1716) = -3d0*cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc** &
                      3d0)
    coupl(nGC_1732) = coupl(nGC_1730)*dZg2_GC22
    coupl(nGC_1733) = coupl(nGC_1731)*dZg1_GC12
    coupl(nGC_1737) = coupl(nGC_1735)*dZg2_GC22
    coupl(nGC_1738) = coupl(nGC_1736)*dZg1_GC12
    coupl(nGC_1741) = coupl(nGC_1739)*dZg2_GC22
    coupl(nGC_1742) = coupl(nGC_1740)*dZg1_GC12
    coupl(nGC_1729) = coupl(nGC_21)*dZg1_GC12
    coupl(nGC_1734) = coupl(nGC_29)*dZg2_GC22
    coupl(nGC_1743) = coupl(nGC_33)*dZg2_GC22
    coupl(nGC_1752) = coupl(nGC_25)*dZgs_QCD2
    coupl(nGC_2396) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0 + coupl(    &
                      nGC_2)*dZPhi1_GC12
    coupl(nGC_2400) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0 + coupl(    &
                      nGC_2)*dZPhi2_GC12
    coupl(nGC_2405) = coupl(nGC_12)*dZPhi1_GC22/2d0 + coupl(nGC_12)*dZPhi2_GC22&
                      /2d0 + coupl(nGC_12)*dZWMinus_GC22/2d0 + coupl(nGC_1732)
    coupl(nGC_2406) = coupl(nGC_12)*dZB0_GC12/2d0 + coupl(nGC_12)*dZPhi1_GC12/ &
                      2d0 + coupl(nGC_12)*dZPhi2_GC12/2d0 + coupl(nGC_1733)
    coupl(nGC_2410) = coupl(nGC_1734) + coupl(nGC_9)*dZPhi1_GC22/2d0 + coupl(  &
                      nGC_9)*dZPhi2_GC22/2d0 + coupl(nGC_9)*dZWMinus_GC22/2d0
    coupl(nGC_2415) = coupl(nGC_10)*dZPhi1_GC22 + coupl(nGC_10)*dZW3_GC22/2d0  &
                       + coupl(nGC_1737)
    coupl(nGC_2416) = coupl(nGC_10)*dZB0_GC12/2d0 + coupl(nGC_10)*dZPhi1_GC12  &
                       + coupl(nGC_1738)
    coupl(nGC_2421) = coupl(nGC_11)*dZPhi2_GC22 + coupl(nGC_11)*dZW3_GC22/2d0  &
                       + coupl(nGC_1741)
    coupl(nGC_2422) = coupl(nGC_11)*dZB0_GC12/2d0 + coupl(nGC_11)*dZPhi2_GC12  &
                       + coupl(nGC_1742)
    coupl(nGC_2426) = coupl(nGC_1743) + coupl(nGC_4)*dZPhi1_GC22 + coupl(nGC_4 &
                      )*dZW3_GC22/2d0
    coupl(nGC_2497) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0
    coupl(nGC_2498) = 2d0*coupl(nGC_2494) + 2d0*coupl(nGC_2497)
    coupl(nGC_2499) = coupl(nGC_2492) + coupl(nGC_2497)
    coupl(nGC_2505) = 2d0*coupl(nGC_2497) + 2d0*coupl(nGC_2502)
    coupl(nGC_2506) = coupl(nGC_2497) + coupl(nGC_2500)
    coupl(nGC_2512) = 2d0*coupl(nGC_2497) + 2d0*coupl(nGC_2509)
    coupl(nGC_2513) = coupl(nGC_2497) + coupl(nGC_2507)
    coupl(nGC_2553) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0 + coupl(    &
                      nGC_2)*dZnu_eL_GC12
    coupl(nGC_2557) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0 + coupl(    &
                      nGC_2)*dZnu_muL_GC12
    coupl(nGC_2561) = coupl(nGC_1729) + coupl(nGC_2)*dZB0_GC12/2d0 + coupl(    &
                      nGC_2)*dZnu_tauL_GC12
    coupl(nGC_2570) = coupl(nGC_17)*dZg_QCD2/2d0 + coupl(nGC_1752)
    coupl(nGC_2571) = coupl(nGC_2567) + coupl(nGC_2570)
    coupl(nGC_2572) = coupl(nGC_2564) + coupl(nGC_2570)
    coupl(nGC_2589) = coupl(nGC_2570) + coupl(nGC_2586)
    coupl(nGC_2590) = coupl(nGC_2570) + coupl(nGC_2583)
    coupl(nGC_2607) = coupl(nGC_2570) + coupl(nGC_2604)
    coupl(nGC_2608) = coupl(nGC_2570) + coupl(nGC_2601)
    coupl(nGC_2625) = coupl(nGC_2570) + coupl(nGC_2622)
    coupl(nGC_2626) = coupl(nGC_2570) + coupl(nGC_2619)
    coupl(nGC_2643) = coupl(nGC_2570) + coupl(nGC_2640)
    coupl(nGC_2644) = coupl(nGC_2570) + coupl(nGC_2637)
    coupl(nGC_2661) = coupl(nGC_2570) + coupl(nGC_2658)
    coupl(nGC_2662) = coupl(nGC_2570) + coupl(nGC_2655)
    coupl(nGC_2675) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZdL_GC22/2d0 + coupl(nGC_9)*dZuL_GC22/2d0
    coupl(nGC_2680) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZcL_GC22/2d0 + coupl(nGC_9)*dZsL_GC22/2d0
    coupl(nGC_2685) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZbL_GC22/2d0 + coupl(nGC_9)*dZtL_GC22/2d0
    coupl(nGC_2689) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZeMinusL_GC22/2d0 + coupl(nGC_9)*dZnu_eL_GC22/2d0
    coupl(nGC_2693) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZmuMinusL_GC22/2d0 + coupl(nGC_9)*dZnu_muL_GC22/ &
                      2d0
    coupl(nGC_2697) = coupl(nGC_1734) + coupl(nGC_9)*dZWMinus_GC22/2d0 + coupl(&
                      nGC_9)*dZnu_tauL_GC22/2d0 + coupl(nGC_9)*dZtauMinusL_GC22&
                      /2d0
    coupl(nGC_2702) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZdL_GC22
    coupl(nGC_2707) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZsL_GC22
    coupl(nGC_2712) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZbL_GC22
    coupl(nGC_2716) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZeMinusL_GC22
    coupl(nGC_2720) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZmuMinusL_GC22
    coupl(nGC_2724) = coupl(nGC_1743) + coupl(nGC_4)*dZW3_GC22/2d0 + coupl(    &
                      nGC_4)*dZtauMinusL_GC22
    coupl(nGC_2975) = -coupl(nGC_2396)
    coupl(nGC_2992) = -coupl(nGC_2400)
    coupl(nGC_3101) = -coupl(nGC_2410)
    coupl(nGC_3305) = -coupl(nGC_2426)
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
