!******************************************************************************!
!                                                                              !
!    ctparameter63.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter63.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter63
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter63()
  DeltaUV = DeltaUV + log(muUV**2/muMS**2)
  dZg1_GC12 = -cima*DeltaUV*coupl(nGC_2)**3d0/(8d0*pi**2d0*g1) + cima*coupl(   &
              nGC_2)*dZB0_MS_GC12/g1 + 2d0*cima*coupl(nGC_2)*dZeMinusL_MS_GC12/&
              g1
  dZg1_GC12 = cone*real(dZg1_GC12,kind=dp)
  DeltaUV = DeltaUV - log(muUV**2/muMS**2)
end subroutine set_ctparameter63
end module ctparameter63
