!******************************************************************************!
!                                                                              !
!    currents_info1.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   currents_info1.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module currents_info1
  implicit none
  contains
  subroutine fill_current_1(check)
    use class_particles
    use current_keys, only: createCurrent
    logical, intent(in) :: check
    call createCurrent(P_g, P_g, P_g, 0, check)
    call createCurrent(P_g, P_g, P_g, P_g, 1, check)
    call createCurrent(P_WPlus, P_W3, P_WMinus, 2, check)
    call createCurrent(P_WPlus, P_W3, P_W3, P_WMinus, 3, check)
    call createCurrent(P_WPlus, P_WPlus, P_WMinus, P_WMinus, 4, check)
    call createCurrent(P_B0, P_B0, P_Phi1, P_Phi1Anti, 5, check)
    call createCurrent(P_B0, P_B0, P_Phi2, P_Phi2Anti, 6, check)
    call createCurrent(P_B0, P_Phi1, P_Phi1Anti, 7, check)
    call createCurrent(P_B0, P_Phi2, P_Phi2Anti, 8, check)
    call createCurrent(P_B0, P_WPlus, P_Phi1Anti, P_Phi2, 9, check)
    call createCurrent(P_WPlus, P_Phi1Anti, P_Phi2, 10, check)
    call createCurrent(P_B0, P_W3, P_Phi1, P_Phi1Anti, 11, check)
    call createCurrent(P_B0, P_W3, P_Phi2, P_Phi2Anti, 12, check)
    call createCurrent(P_W3, P_Phi1, P_Phi1Anti, 13, check)
    call createCurrent(P_W3, P_Phi2, P_Phi2Anti, 14, check)
    call createCurrent(P_W3, P_W3, P_Phi1, P_Phi1Anti, 15, check)
    call createCurrent(P_W3, P_W3, P_Phi2, P_Phi2Anti, 16, check)
    call createCurrent(P_B0, P_WMinus, P_Phi1, P_Phi2Anti, 17, check)
    call createCurrent(P_WMinus, P_Phi1, P_Phi2Anti, 18, check)
    call createCurrent(P_WPlus, P_WMinus, P_Phi1, P_Phi1Anti, 19, check)
    call createCurrent(P_WPlus, P_WMinus, P_Phi2, P_Phi2Anti, 20, check)
    call createCurrent(P_d, P_dAnti, P_B0, 21, check)
    call createCurrent(P_s, P_sAnti, P_B0, 22, check)
    call createCurrent(P_b, P_bAnti, P_B0, 23, check)
    call createCurrent(P_eMinus, P_ePlus, P_B0, 24, check)
    call createCurrent(P_muMinus, P_muPlus, P_B0, 25, check)
    call createCurrent(P_tauMinus, P_tauPlus, P_B0, 26, check)
    call createCurrent(P_u, P_uAnti, P_B0, 27, check)
    call createCurrent(P_c, P_cAnti, P_B0, 28, check)
    call createCurrent(P_t, P_tAnti, P_B0, 29, check)
    call createCurrent(P_nu_e, P_nu_eAnti, P_B0, 30, check)
    call createCurrent(P_nu_mu, P_nu_muAnti, P_B0, 31, check)
    call createCurrent(P_nu_tau, P_nu_tauAnti, P_B0, 32, check)
    call createCurrent(P_d, P_dAnti, P_g, 33, check)
    call createCurrent(P_s, P_sAnti, P_g, 34, check)
    call createCurrent(P_b, P_bAnti, P_g, 35, check)
    call createCurrent(P_u, P_uAnti, P_g, 36, check)
    call createCurrent(P_c, P_cAnti, P_g, 37, check)
    call createCurrent(P_t, P_tAnti, P_g, 38, check)
    call createCurrent(P_d, P_uAnti, P_WPlus, 39, check)
    call createCurrent(P_s, P_cAnti, P_WPlus, 40, check)
    call createCurrent(P_b, P_tAnti, P_WPlus, 41, check)
    call createCurrent(P_eMinus, P_nu_eAnti, P_WPlus, 42, check)
    call createCurrent(P_muMinus, P_nu_muAnti, P_WPlus, 43, check)
    call createCurrent(P_tauMinus, P_nu_tauAnti, P_WPlus, 44, check)
    call createCurrent(P_d, P_dAnti, P_W3, 45, check)
    call createCurrent(P_s, P_sAnti, P_W3, 46, check)
    call createCurrent(P_b, P_bAnti, P_W3, 47, check)
    call createCurrent(P_eMinus, P_ePlus, P_W3, 48, check)
    call createCurrent(P_muMinus, P_muPlus, P_W3, 49, check)
    call createCurrent(P_tauMinus, P_tauPlus, P_W3, 50, check)
    call createCurrent(P_u, P_uAnti, P_W3, 51, check)
    call createCurrent(P_c, P_cAnti, P_W3, 52, check)
    call createCurrent(P_t, P_tAnti, P_W3, 53, check)
    call createCurrent(P_nu_e, P_nu_eAnti, P_W3, 54, check)
    call createCurrent(P_nu_mu, P_nu_muAnti, P_W3, 55, check)
    call createCurrent(P_nu_tau, P_nu_tauAnti, P_W3, 56, check)
    call createCurrent(P_u, P_dAnti, P_WMinus, 57, check)
    call createCurrent(P_c, P_sAnti, P_WMinus, 58, check)
    call createCurrent(P_t, P_bAnti, P_WMinus, 59, check)
    call createCurrent(P_nu_e, P_ePlus, P_WMinus, 60, check)
    call createCurrent(P_nu_mu, P_muPlus, P_WMinus, 61, check)
    call createCurrent(P_nu_tau, P_tauPlus, P_WMinus, 62, check)
    call createCurrent(P_ghW3Anti, P_ghWm, P_WPlus, 63, check)
    call createCurrent(P_ghW3Anti, P_ghWp, P_WMinus, 64, check)
    call createCurrent(P_ghWmAnti, P_ghW3, P_WMinus, 65, check)
    call createCurrent(P_ghWmAnti, P_ghWm, P_W3, 66, check)
    call createCurrent(P_ghWpAnti, P_ghW3, P_WPlus, 67, check)
    call createCurrent(P_ghWpAnti, P_ghWp, P_W3, 68, check)
    call createCurrent(P_ghGAnti, P_ghG, P_g, 69, check)
    call createCurrent(P_WMinus, P_WPlus, P_W3, 70, check)
    call createCurrent(P_WMinus, P_W3, P_WPlus, 71, check)
    call createCurrent(P_WPlus, P_WMinus, P_W3, 72, check)
    call createCurrent(P_W3, P_WMinus, P_WPlus, 73, check)
    call createCurrent(P_W3, P_WPlus, P_WMinus, 74, check)
    call createCurrent(P_WMinus, P_WPlus, P_W3, P_W3, 75, check)
    call createCurrent(P_WMinus, P_W3, P_WPlus, P_W3, 76, check)
    call createCurrent(P_WMinus, P_W3, P_W3, P_WPlus, 77, check)
    call createCurrent(P_WPlus, P_WMinus, P_W3, P_W3, 78, check)
    call createCurrent(P_WPlus, P_W3, P_WMinus, P_W3, 79, check)
    call createCurrent(P_W3, P_WMinus, P_WPlus, P_W3, 80, check)
    call createCurrent(P_W3, P_WMinus, P_W3, P_WPlus, 81, check)
    call createCurrent(P_W3, P_WPlus, P_WMinus, P_W3, 82, check)
    call createCurrent(P_W3, P_WPlus, P_W3, P_WMinus, 83, check)
    call createCurrent(P_W3, P_W3, P_WMinus, P_WPlus, 84, check)
    call createCurrent(P_W3, P_W3, P_WPlus, P_WMinus, 85, check)
    call createCurrent(P_WMinus, P_WMinus, P_WPlus, P_WPlus, 86, check)
    call createCurrent(P_WMinus, P_WPlus, P_WMinus, P_WPlus, 87, check)
    call createCurrent(P_WMinus, P_WPlus, P_WPlus, P_WMinus, 88, check)
    call createCurrent(P_WPlus, P_WMinus, P_WMinus, P_WPlus, 89, check)
    call createCurrent(P_WPlus, P_WMinus, P_WPlus, P_WMinus, 90, check)
    call createCurrent(P_B0, P_B0, P_Phi1Anti, P_Phi1, 91, check)
    call createCurrent(P_B0, P_Phi1, P_B0, P_Phi1Anti, 92, check)
    call createCurrent(P_B0, P_Phi1, P_Phi1Anti, P_B0, 93, check)
    call createCurrent(P_B0, P_Phi1Anti, P_B0, P_Phi1, 94, check)
    call createCurrent(P_B0, P_Phi1Anti, P_Phi1, P_B0, 95, check)
    call createCurrent(P_Phi1, P_B0, P_B0, P_Phi1Anti, 96, check)
    call createCurrent(P_Phi1, P_B0, P_Phi1Anti, P_B0, 97, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_B0, P_B0, 98, check)
    call createCurrent(P_Phi1Anti, P_B0, P_B0, P_Phi1, 99, check)
    call createCurrent(P_Phi1Anti, P_B0, P_Phi1, P_B0, 100, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_B0, P_B0, 101, check)
    call createCurrent(P_B0, P_B0, P_Phi2Anti, P_Phi2, 102, check)
    call createCurrent(P_B0, P_Phi2Anti, P_B0, P_Phi2, 103, check)
    call createCurrent(P_B0, P_Phi2Anti, P_Phi2, P_B0, 104, check)
    call createCurrent(P_B0, P_Phi2, P_B0, P_Phi2Anti, 105, check)
    call createCurrent(P_B0, P_Phi2, P_Phi2Anti, P_B0, 106, check)
    call createCurrent(P_Phi2Anti, P_B0, P_B0, P_Phi2, 107, check)
    call createCurrent(P_Phi2Anti, P_B0, P_Phi2, P_B0, 108, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_B0, P_B0, 109, check)
    call createCurrent(P_Phi2, P_B0, P_B0, P_Phi2Anti, 110, check)
    call createCurrent(P_Phi2, P_B0, P_Phi2Anti, P_B0, 111, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_B0, P_B0, 112, check)
    call createCurrent(P_B0, P_Phi1Anti, P_Phi1, 113, check)
    call createCurrent(P_Phi1, P_B0, P_Phi1Anti, 114, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_B0, 115, check)
    call createCurrent(P_Phi1Anti, P_B0, P_Phi1, 116, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_B0, 117, check)
    call createCurrent(P_B0, P_Phi2Anti, P_Phi2, 118, check)
    call createCurrent(P_Phi2Anti, P_B0, P_Phi2, 119, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_B0, 120, check)
    call createCurrent(P_Phi2, P_B0, P_Phi2Anti, 121, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_B0, 122, check)
    call createCurrent(P_B0, P_Phi1Anti, P_WPlus, P_Phi2, 123, check)
    call createCurrent(P_B0, P_Phi1Anti, P_Phi2, P_WPlus, 124, check)
    call createCurrent(P_B0, P_WPlus, P_Phi2, P_Phi1Anti, 125, check)
    call createCurrent(P_B0, P_Phi2, P_Phi1Anti, P_WPlus, 126, check)
    call createCurrent(P_B0, P_Phi2, P_WPlus, P_Phi1Anti, 127, check)
    call createCurrent(P_Phi1Anti, P_B0, P_WPlus, P_Phi2, 128, check)
    call createCurrent(P_Phi1Anti, P_B0, P_Phi2, P_WPlus, 129, check)
    call createCurrent(P_Phi1Anti, P_WPlus, P_B0, P_Phi2, 130, check)
    call createCurrent(P_Phi1Anti, P_WPlus, P_Phi2, P_B0, 131, check)
    call createCurrent(P_Phi1Anti, P_Phi2, P_B0, P_WPlus, 132, check)
    call createCurrent(P_Phi1Anti, P_Phi2, P_WPlus, P_B0, 133, check)
    call createCurrent(P_WPlus, P_B0, P_Phi1Anti, P_Phi2, 134, check)
    call createCurrent(P_WPlus, P_B0, P_Phi2, P_Phi1Anti, 135, check)
    call createCurrent(P_WPlus, P_Phi1Anti, P_B0, P_Phi2, 136, check)
    call createCurrent(P_WPlus, P_Phi1Anti, P_Phi2, P_B0, 137, check)
    call createCurrent(P_WPlus, P_Phi2, P_B0, P_Phi1Anti, 138, check)
    call createCurrent(P_WPlus, P_Phi2, P_Phi1Anti, P_B0, 139, check)
    call createCurrent(P_Phi2, P_B0, P_Phi1Anti, P_WPlus, 140, check)
    call createCurrent(P_Phi2, P_B0, P_WPlus, P_Phi1Anti, 141, check)
    call createCurrent(P_Phi2, P_Phi1Anti, P_B0, P_WPlus, 142, check)
    call createCurrent(P_Phi2, P_Phi1Anti, P_WPlus, P_B0, 143, check)
    call createCurrent(P_Phi2, P_WPlus, P_B0, P_Phi1Anti, 144, check)
    call createCurrent(P_Phi2, P_WPlus, P_Phi1Anti, P_B0, 145, check)
    call createCurrent(P_Phi1Anti, P_WPlus, P_Phi2, 146, check)
    call createCurrent(P_Phi1Anti, P_Phi2, P_WPlus, 147, check)
    call createCurrent(P_WPlus, P_Phi2, P_Phi1Anti, 148, check)
    call createCurrent(P_Phi2, P_Phi1Anti, P_WPlus, 149, check)
    call createCurrent(P_Phi2, P_WPlus, P_Phi1Anti, 150, check)
    call createCurrent(P_B0, P_Phi1, P_Phi1Anti, P_W3, 151, check)
    call createCurrent(P_B0, P_Phi1, P_W3, P_Phi1Anti, 152, check)
    call createCurrent(P_B0, P_Phi1Anti, P_Phi1, P_W3, 153, check)
    call createCurrent(P_B0, P_Phi1Anti, P_W3, P_Phi1, 154, check)
    call createCurrent(P_B0, P_W3, P_Phi1Anti, P_Phi1, 155, check)
    call createCurrent(P_Phi1, P_B0, P_Phi1Anti, P_W3, 156, check)
    call createCurrent(P_Phi1, P_B0, P_W3, P_Phi1Anti, 157, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_B0, P_W3, 158, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_W3, P_B0, 159, check)
    call createCurrent(P_Phi1, P_W3, P_B0, P_Phi1Anti, 160, check)
    call createCurrent(P_Phi1, P_W3, P_Phi1Anti, P_B0, 161, check)
    call createCurrent(P_Phi1Anti, P_B0, P_Phi1, P_W3, 162, check)
    call createCurrent(P_Phi1Anti, P_B0, P_W3, P_Phi1, 163, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_B0, P_W3, 164, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_W3, P_B0, 165, check)
    call createCurrent(P_Phi1Anti, P_W3, P_B0, P_Phi1, 166, check)
    call createCurrent(P_Phi1Anti, P_W3, P_Phi1, P_B0, 167, check)
    call createCurrent(P_W3, P_B0, P_Phi1, P_Phi1Anti, 168, check)
    call createCurrent(P_W3, P_B0, P_Phi1Anti, P_Phi1, 169, check)
    call createCurrent(P_W3, P_Phi1, P_B0, P_Phi1Anti, 170, check)
    call createCurrent(P_W3, P_Phi1, P_Phi1Anti, P_B0, 171, check)
    call createCurrent(P_W3, P_Phi1Anti, P_B0, P_Phi1, 172, check)
    call createCurrent(P_W3, P_Phi1Anti, P_Phi1, P_B0, 173, check)
    call createCurrent(P_B0, P_Phi2, P_Phi2Anti, P_W3, 174, check)
    call createCurrent(P_B0, P_Phi2, P_W3, P_Phi2Anti, 175, check)
    call createCurrent(P_B0, P_Phi2Anti, P_Phi2, P_W3, 176, check)
    call createCurrent(P_B0, P_Phi2Anti, P_W3, P_Phi2, 177, check)
    call createCurrent(P_B0, P_W3, P_Phi2Anti, P_Phi2, 178, check)
    call createCurrent(P_Phi2, P_B0, P_Phi2Anti, P_W3, 179, check)
    call createCurrent(P_Phi2, P_B0, P_W3, P_Phi2Anti, 180, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_B0, P_W3, 181, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_W3, P_B0, 182, check)
    call createCurrent(P_Phi2, P_W3, P_B0, P_Phi2Anti, 183, check)
    call createCurrent(P_Phi2, P_W3, P_Phi2Anti, P_B0, 184, check)
    call createCurrent(P_Phi2Anti, P_B0, P_Phi2, P_W3, 185, check)
    call createCurrent(P_Phi2Anti, P_B0, P_W3, P_Phi2, 186, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_B0, P_W3, 187, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_W3, P_B0, 188, check)
    call createCurrent(P_Phi2Anti, P_W3, P_B0, P_Phi2, 189, check)
    call createCurrent(P_Phi2Anti, P_W3, P_Phi2, P_B0, 190, check)
    call createCurrent(P_W3, P_B0, P_Phi2Anti, P_Phi2, 191, check)
    call createCurrent(P_W3, P_B0, P_Phi2, P_Phi2Anti, 192, check)
    call createCurrent(P_W3, P_Phi2Anti, P_B0, P_Phi2, 193, check)
    call createCurrent(P_W3, P_Phi2Anti, P_Phi2, P_B0, 194, check)
    call createCurrent(P_W3, P_Phi2, P_B0, P_Phi2Anti, 195, check)
    call createCurrent(P_W3, P_Phi2, P_Phi2Anti, P_B0, 196, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_W3, 197, check)
    call createCurrent(P_Phi1, P_W3, P_Phi1Anti, 198, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_W3, 199, check)
    call createCurrent(P_Phi1Anti, P_W3, P_Phi1, 200, check)
    call createCurrent(P_W3, P_Phi1Anti, P_Phi1, 201, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_W3, 202, check)
    call createCurrent(P_Phi2, P_W3, P_Phi2Anti, 203, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_W3, 204, check)
    call createCurrent(P_Phi2Anti, P_W3, P_Phi2, 205, check)
    call createCurrent(P_W3, P_Phi2Anti, P_Phi2, 206, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_W3, P_W3, 207, check)
    call createCurrent(P_Phi1, P_W3, P_Phi1Anti, P_W3, 208, check)
    call createCurrent(P_Phi1, P_W3, P_W3, P_Phi1Anti, 209, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_W3, P_W3, 210, check)
    call createCurrent(P_Phi1Anti, P_W3, P_Phi1, P_W3, 211, check)
    call createCurrent(P_Phi1Anti, P_W3, P_W3, P_Phi1, 212, check)
    call createCurrent(P_W3, P_Phi1, P_Phi1Anti, P_W3, 213, check)
    call createCurrent(P_W3, P_Phi1, P_W3, P_Phi1Anti, 214, check)
    call createCurrent(P_W3, P_Phi1Anti, P_Phi1, P_W3, 215, check)
    call createCurrent(P_W3, P_Phi1Anti, P_W3, P_Phi1, 216, check)
    call createCurrent(P_W3, P_W3, P_Phi1Anti, P_Phi1, 217, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_W3, P_W3, 218, check)
    call createCurrent(P_Phi2, P_W3, P_Phi2Anti, P_W3, 219, check)
    call createCurrent(P_Phi2, P_W3, P_W3, P_Phi2Anti, 220, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_W3, P_W3, 221, check)
    call createCurrent(P_Phi2Anti, P_W3, P_Phi2, P_W3, 222, check)
    call createCurrent(P_Phi2Anti, P_W3, P_W3, P_Phi2, 223, check)
    call createCurrent(P_W3, P_Phi2, P_Phi2Anti, P_W3, 224, check)
    call createCurrent(P_W3, P_Phi2, P_W3, P_Phi2Anti, 225, check)
    call createCurrent(P_W3, P_Phi2Anti, P_Phi2, P_W3, 226, check)
    call createCurrent(P_W3, P_Phi2Anti, P_W3, P_Phi2, 227, check)
    call createCurrent(P_W3, P_W3, P_Phi2Anti, P_Phi2, 228, check)
    call createCurrent(P_B0, P_WMinus, P_Phi2Anti, P_Phi1, 229, check)
    call createCurrent(P_B0, P_Phi1, P_WMinus, P_Phi2Anti, 230, check)
    call createCurrent(P_B0, P_Phi1, P_Phi2Anti, P_WMinus, 231, check)
    call createCurrent(P_B0, P_Phi2Anti, P_WMinus, P_Phi1, 232, check)
    call createCurrent(P_B0, P_Phi2Anti, P_Phi1, P_WMinus, 233, check)
    call createCurrent(P_Phi1, P_WMinus, P_B0, P_Phi2Anti, 234, check)
    call createCurrent(P_Phi1, P_WMinus, P_Phi2Anti, P_B0, 235, check)
    call createCurrent(P_Phi1, P_Phi2Anti, P_B0, P_WMinus, 236, check)
    call createCurrent(P_Phi1, P_Phi2Anti, P_WMinus, P_B0, 237, check)
    call createCurrent(P_Phi1, P_B0, P_WMinus, P_Phi2Anti, 238, check)
    call createCurrent(P_Phi1, P_B0, P_Phi2Anti, P_WMinus, 239, check)
    call createCurrent(P_Phi2Anti, P_WMinus, P_B0, P_Phi1, 240, check)
    call createCurrent(P_Phi2Anti, P_WMinus, P_Phi1, P_B0, 241, check)
    call createCurrent(P_Phi2Anti, P_Phi1, P_B0, P_WMinus, 242, check)
    call createCurrent(P_Phi2Anti, P_Phi1, P_WMinus, P_B0, 243, check)
    call createCurrent(P_Phi2Anti, P_B0, P_WMinus, P_Phi1, 244, check)
    call createCurrent(P_Phi2Anti, P_B0, P_Phi1, P_WMinus, 245, check)
    call createCurrent(P_WMinus, P_B0, P_Phi1, P_Phi2Anti, 246, check)
    call createCurrent(P_WMinus, P_B0, P_Phi2Anti, P_Phi1, 247, check)
    call createCurrent(P_WMinus, P_Phi1, P_B0, P_Phi2Anti, 248, check)
    call createCurrent(P_WMinus, P_Phi1, P_Phi2Anti, P_B0, 249, check)
    call createCurrent(P_WMinus, P_Phi2Anti, P_B0, P_Phi1, 250, check)
    call createCurrent(P_WMinus, P_Phi2Anti, P_Phi1, P_B0, 251, check)
    call createCurrent(P_WMinus, P_Phi2Anti, P_Phi1, 252, check)
    call createCurrent(P_Phi1, P_WMinus, P_Phi2Anti, 253, check)
    call createCurrent(P_Phi1, P_Phi2Anti, P_WMinus, 254, check)
    call createCurrent(P_Phi2Anti, P_WMinus, P_Phi1, 255, check)
    call createCurrent(P_Phi2Anti, P_Phi1, P_WMinus, 256, check)
    call createCurrent(P_WMinus, P_Phi1, P_Phi1Anti, P_WPlus, 257, check)
    call createCurrent(P_WMinus, P_Phi1, P_WPlus, P_Phi1Anti, 258, check)
    call createCurrent(P_WMinus, P_Phi1Anti, P_Phi1, P_WPlus, 259, check)
    call createCurrent(P_WMinus, P_Phi1Anti, P_WPlus, P_Phi1, 260, check)
    call createCurrent(P_WMinus, P_WPlus, P_Phi1, P_Phi1Anti, 261, check)
    call createCurrent(P_WMinus, P_WPlus, P_Phi1Anti, P_Phi1, 262, check)
    call createCurrent(P_Phi1, P_WMinus, P_Phi1Anti, P_WPlus, 263, check)
    call createCurrent(P_Phi1, P_WMinus, P_WPlus, P_Phi1Anti, 264, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_WMinus, P_WPlus, 265, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_WPlus, P_WMinus, 266, check)
    call createCurrent(P_Phi1, P_WPlus, P_WMinus, P_Phi1Anti, 267, check)
    call createCurrent(P_Phi1, P_WPlus, P_Phi1Anti, P_WMinus, 268, check)
    call createCurrent(P_Phi1Anti, P_WMinus, P_Phi1, P_WPlus, 269, check)
    call createCurrent(P_Phi1Anti, P_WMinus, P_WPlus, P_Phi1, 270, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_WMinus, P_WPlus, 271, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_WPlus, P_WMinus, 272, check)
    call createCurrent(P_Phi1Anti, P_WPlus, P_WMinus, P_Phi1, 273, check)
    call createCurrent(P_Phi1Anti, P_WPlus, P_Phi1, P_WMinus, 274, check)
    call createCurrent(P_WPlus, P_WMinus, P_Phi1Anti, P_Phi1, 275, check)
    call createCurrent(P_WPlus, P_Phi1, P_WMinus, P_Phi1Anti, 276, check)
    call createCurrent(P_WPlus, P_Phi1, P_Phi1Anti, P_WMinus, 277, check)
    call createCurrent(P_WPlus, P_Phi1Anti, P_WMinus, P_Phi1, 278, check)
    call createCurrent(P_WPlus, P_Phi1Anti, P_Phi1, P_WMinus, 279, check)
    call createCurrent(P_WMinus, P_Phi2Anti, P_WPlus, P_Phi2, 280, check)
    call createCurrent(P_WMinus, P_Phi2Anti, P_Phi2, P_WPlus, 281, check)
    call createCurrent(P_WMinus, P_WPlus, P_Phi2Anti, P_Phi2, 282, check)
    call createCurrent(P_WMinus, P_WPlus, P_Phi2, P_Phi2Anti, 283, check)
    call createCurrent(P_WMinus, P_Phi2, P_Phi2Anti, P_WPlus, 284, check)
    call createCurrent(P_WMinus, P_Phi2, P_WPlus, P_Phi2Anti, 285, check)
    call createCurrent(P_Phi2Anti, P_WMinus, P_WPlus, P_Phi2, 286, check)
    call createCurrent(P_Phi2Anti, P_WMinus, P_Phi2, P_WPlus, 287, check)
    call createCurrent(P_Phi2Anti, P_WPlus, P_WMinus, P_Phi2, 288, check)
    call createCurrent(P_Phi2Anti, P_WPlus, P_Phi2, P_WMinus, 289, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_WMinus, P_WPlus, 290, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_WPlus, P_WMinus, 291, check)
    call createCurrent(P_WPlus, P_WMinus, P_Phi2Anti, P_Phi2, 292, check)
    call createCurrent(P_WPlus, P_Phi2Anti, P_WMinus, P_Phi2, 293, check)
    call createCurrent(P_WPlus, P_Phi2Anti, P_Phi2, P_WMinus, 294, check)
    call createCurrent(P_WPlus, P_Phi2, P_WMinus, P_Phi2Anti, 295, check)
    call createCurrent(P_WPlus, P_Phi2, P_Phi2Anti, P_WMinus, 296, check)
    call createCurrent(P_Phi2, P_WMinus, P_Phi2Anti, P_WPlus, 297, check)
    call createCurrent(P_Phi2, P_WMinus, P_WPlus, P_Phi2Anti, 298, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_WMinus, P_WPlus, 299, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_WPlus, P_WMinus, 300, check)
    call createCurrent(P_Phi2, P_WPlus, P_WMinus, P_Phi2Anti, 301, check)
    call createCurrent(P_Phi2, P_WPlus, P_Phi2Anti, P_WMinus, 302, check)
    call createCurrent(P_B0, P_dAnti, P_d, 303, check)
    call createCurrent(P_B0, P_d, P_dAnti, 304, check)
    call createCurrent(P_dAnti, P_B0, P_d, 305, check)
    call createCurrent(P_dAnti, P_d, P_B0, 306, check)
    call createCurrent(P_d, P_B0, P_dAnti, 307, check)
    call createCurrent(P_sAnti, P_B0, P_s, 308, check)
    call createCurrent(P_sAnti, P_s, P_B0, 309, check)
    call createCurrent(P_B0, P_sAnti, P_s, 310, check)
    call createCurrent(P_B0, P_s, P_sAnti, 311, check)
    call createCurrent(P_s, P_B0, P_sAnti, 312, check)
    call createCurrent(P_B0, P_b, P_bAnti, 313, check)
    call createCurrent(P_B0, P_bAnti, P_b, 314, check)
    call createCurrent(P_b, P_B0, P_bAnti, 315, check)
    call createCurrent(P_bAnti, P_B0, P_b, 316, check)
    call createCurrent(P_bAnti, P_b, P_B0, 317, check)
    call createCurrent(P_B0, P_eMinus, P_ePlus, 318, check)
    call createCurrent(P_B0, P_ePlus, P_eMinus, 319, check)
    call createCurrent(P_eMinus, P_B0, P_ePlus, 320, check)
    call createCurrent(P_ePlus, P_B0, P_eMinus, 321, check)
    call createCurrent(P_ePlus, P_eMinus, P_B0, 322, check)
    call createCurrent(P_B0, P_muMinus, P_muPlus, 323, check)
    call createCurrent(P_B0, P_muPlus, P_muMinus, 324, check)
    call createCurrent(P_muMinus, P_B0, P_muPlus, 325, check)
    call createCurrent(P_muPlus, P_B0, P_muMinus, 326, check)
    call createCurrent(P_muPlus, P_muMinus, P_B0, 327, check)
    call createCurrent(P_B0, P_tauPlus, P_tauMinus, 328, check)
    call createCurrent(P_B0, P_tauMinus, P_tauPlus, 329, check)
    call createCurrent(P_tauPlus, P_B0, P_tauMinus, 330, check)
    call createCurrent(P_tauPlus, P_tauMinus, P_B0, 331, check)
    call createCurrent(P_tauMinus, P_B0, P_tauPlus, 332, check)
    call createCurrent(P_uAnti, P_B0, P_u, 333, check)
    call createCurrent(P_uAnti, P_u, P_B0, 334, check)
    call createCurrent(P_B0, P_uAnti, P_u, 335, check)
    call createCurrent(P_B0, P_u, P_uAnti, 336, check)
    call createCurrent(P_u, P_B0, P_uAnti, 337, check)
    call createCurrent(P_B0, P_c, P_cAnti, 338, check)
    call createCurrent(P_B0, P_cAnti, P_c, 339, check)
    call createCurrent(P_c, P_B0, P_cAnti, 340, check)
    call createCurrent(P_cAnti, P_B0, P_c, 341, check)
    call createCurrent(P_cAnti, P_c, P_B0, 342, check)
    call createCurrent(P_B0, P_t, P_tAnti, 343, check)
    call createCurrent(P_B0, P_tAnti, P_t, 344, check)
    call createCurrent(P_t, P_B0, P_tAnti, 345, check)
    call createCurrent(P_tAnti, P_B0, P_t, 346, check)
    call createCurrent(P_tAnti, P_t, P_B0, 347, check)
    call createCurrent(P_nu_eAnti, P_B0, P_nu_e, 348, check)
    call createCurrent(P_nu_eAnti, P_nu_e, P_B0, 349, check)
    call createCurrent(P_nu_e, P_B0, P_nu_eAnti, 350, check)
    call createCurrent(P_B0, P_nu_eAnti, P_nu_e, 351, check)
    call createCurrent(P_B0, P_nu_e, P_nu_eAnti, 352, check)
    call createCurrent(P_B0, P_nu_muAnti, P_nu_mu, 353, check)
    call createCurrent(P_B0, P_nu_mu, P_nu_muAnti, 354, check)
    call createCurrent(P_nu_muAnti, P_B0, P_nu_mu, 355, check)
    call createCurrent(P_nu_muAnti, P_nu_mu, P_B0, 356, check)
    call createCurrent(P_nu_mu, P_B0, P_nu_muAnti, 357, check)
    call createCurrent(P_nu_tauAnti, P_B0, P_nu_tau, 358, check)
    call createCurrent(P_nu_tauAnti, P_nu_tau, P_B0, 359, check)
    call createCurrent(P_B0, P_nu_tauAnti, P_nu_tau, 360, check)
    call createCurrent(P_B0, P_nu_tau, P_nu_tauAnti, 361, check)
    call createCurrent(P_nu_tau, P_B0, P_nu_tauAnti, 362, check)
    call createCurrent(P_dAnti, P_g, P_d, 363, check)
    call createCurrent(P_dAnti, P_d, P_g, 364, check)
    call createCurrent(P_g, P_dAnti, P_d, 365, check)
    call createCurrent(P_g, P_d, P_dAnti, 366, check)
    call createCurrent(P_d, P_g, P_dAnti, 367, check)
    call createCurrent(P_sAnti, P_g, P_s, 368, check)
    call createCurrent(P_sAnti, P_s, P_g, 369, check)
    call createCurrent(P_g, P_sAnti, P_s, 370, check)
    call createCurrent(P_g, P_s, P_sAnti, 371, check)
    call createCurrent(P_s, P_g, P_sAnti, 372, check)
    call createCurrent(P_b, P_g, P_bAnti, 373, check)
    call createCurrent(P_g, P_b, P_bAnti, 374, check)
    call createCurrent(P_g, P_bAnti, P_b, 375, check)
    call createCurrent(P_bAnti, P_b, P_g, 376, check)
    call createCurrent(P_bAnti, P_g, P_b, 377, check)
    call createCurrent(P_uAnti, P_g, P_u, 378, check)
    call createCurrent(P_uAnti, P_u, P_g, 379, check)
    call createCurrent(P_g, P_uAnti, P_u, 380, check)
    call createCurrent(P_g, P_u, P_uAnti, 381, check)
    call createCurrent(P_u, P_g, P_uAnti, 382, check)
    call createCurrent(P_c, P_g, P_cAnti, 383, check)
    call createCurrent(P_g, P_c, P_cAnti, 384, check)
    call createCurrent(P_g, P_cAnti, P_c, 385, check)
    call createCurrent(P_cAnti, P_c, P_g, 386, check)
    call createCurrent(P_cAnti, P_g, P_c, 387, check)
    call createCurrent(P_t, P_g, P_tAnti, 388, check)
    call createCurrent(P_tAnti, P_t, P_g, 389, check)
    call createCurrent(P_tAnti, P_g, P_t, 390, check)
    call createCurrent(P_g, P_t, P_tAnti, 391, check)
    call createCurrent(P_g, P_tAnti, P_t, 392, check)
    call createCurrent(P_uAnti, P_WPlus, P_d, 393, check)
    call createCurrent(P_uAnti, P_d, P_WPlus, 394, check)
    call createCurrent(P_WPlus, P_uAnti, P_d, 395, check)
    call createCurrent(P_WPlus, P_d, P_uAnti, 396, check)
    call createCurrent(P_d, P_WPlus, P_uAnti, 397, check)
    call createCurrent(P_WPlus, P_s, P_cAnti, 398, check)
    call createCurrent(P_WPlus, P_cAnti, P_s, 399, check)
    call createCurrent(P_s, P_WPlus, P_cAnti, 400, check)
    call createCurrent(P_cAnti, P_s, P_WPlus, 401, check)
    call createCurrent(P_cAnti, P_WPlus, P_s, 402, check)
    call createCurrent(P_b, P_WPlus, P_tAnti, 403, check)
    call createCurrent(P_tAnti, P_b, P_WPlus, 404, check)
    call createCurrent(P_tAnti, P_WPlus, P_b, 405, check)
    call createCurrent(P_WPlus, P_b, P_tAnti, 406, check)
    call createCurrent(P_WPlus, P_tAnti, P_b, 407, check)
    call createCurrent(P_nu_eAnti, P_eMinus, P_WPlus, 408, check)
    call createCurrent(P_nu_eAnti, P_WPlus, P_eMinus, 409, check)
    call createCurrent(P_eMinus, P_WPlus, P_nu_eAnti, 410, check)
    call createCurrent(P_WPlus, P_nu_eAnti, P_eMinus, 411, check)
    call createCurrent(P_WPlus, P_eMinus, P_nu_eAnti, 412, check)
    call createCurrent(P_muMinus, P_WPlus, P_nu_muAnti, 413, check)
    call createCurrent(P_nu_muAnti, P_muMinus, P_WPlus, 414, check)
    call createCurrent(P_nu_muAnti, P_WPlus, P_muMinus, 415, check)
    call createCurrent(P_WPlus, P_muMinus, P_nu_muAnti, 416, check)
    call createCurrent(P_WPlus, P_nu_muAnti, P_muMinus, 417, check)
    call createCurrent(P_nu_tauAnti, P_WPlus, P_tauMinus, 418, check)
    call createCurrent(P_nu_tauAnti, P_tauMinus, P_WPlus, 419, check)
    call createCurrent(P_WPlus, P_nu_tauAnti, P_tauMinus, 420, check)
    call createCurrent(P_WPlus, P_tauMinus, P_nu_tauAnti, 421, check)
    call createCurrent(P_tauMinus, P_WPlus, P_nu_tauAnti, 422, check)
    call createCurrent(P_dAnti, P_W3, P_d, 423, check)
    call createCurrent(P_dAnti, P_d, P_W3, 424, check)
    call createCurrent(P_W3, P_dAnti, P_d, 425, check)
    call createCurrent(P_W3, P_d, P_dAnti, 426, check)
    call createCurrent(P_d, P_W3, P_dAnti, 427, check)
    call createCurrent(P_sAnti, P_s, P_W3, 428, check)
    call createCurrent(P_sAnti, P_W3, P_s, 429, check)
    call createCurrent(P_s, P_W3, P_sAnti, 430, check)
    call createCurrent(P_W3, P_sAnti, P_s, 431, check)
    call createCurrent(P_W3, P_s, P_sAnti, 432, check)
    call createCurrent(P_b, P_W3, P_bAnti, 433, check)
    call createCurrent(P_bAnti, P_b, P_W3, 434, check)
    call createCurrent(P_bAnti, P_W3, P_b, 435, check)
    call createCurrent(P_W3, P_b, P_bAnti, 436, check)
    call createCurrent(P_W3, P_bAnti, P_b, 437, check)
    call createCurrent(P_eMinus, P_W3, P_ePlus, 438, check)
    call createCurrent(P_ePlus, P_eMinus, P_W3, 439, check)
    call createCurrent(P_ePlus, P_W3, P_eMinus, 440, check)
    call createCurrent(P_W3, P_eMinus, P_ePlus, 441, check)
    call createCurrent(P_W3, P_ePlus, P_eMinus, 442, check)
    call createCurrent(P_muMinus, P_W3, P_muPlus, 443, check)
    call createCurrent(P_muPlus, P_muMinus, P_W3, 444, check)
    call createCurrent(P_muPlus, P_W3, P_muMinus, 445, check)
    call createCurrent(P_W3, P_muMinus, P_muPlus, 446, check)
    call createCurrent(P_W3, P_muPlus, P_muMinus, 447, check)
    call createCurrent(P_tauPlus, P_W3, P_tauMinus, 448, check)
    call createCurrent(P_tauPlus, P_tauMinus, P_W3, 449, check)
    call createCurrent(P_W3, P_tauPlus, P_tauMinus, 450, check)
    call createCurrent(P_W3, P_tauMinus, P_tauPlus, 451, check)
    call createCurrent(P_tauMinus, P_W3, P_tauPlus, 452, check)
    call createCurrent(P_uAnti, P_u, P_W3, 453, check)
    call createCurrent(P_uAnti, P_W3, P_u, 454, check)
    call createCurrent(P_u, P_W3, P_uAnti, 455, check)
    call createCurrent(P_W3, P_uAnti, P_u, 456, check)
    call createCurrent(P_W3, P_u, P_uAnti, 457, check)
    call createCurrent(P_c, P_W3, P_cAnti, 458, check)
    call createCurrent(P_cAnti, P_c, P_W3, 459, check)
    call createCurrent(P_cAnti, P_W3, P_c, 460, check)
    call createCurrent(P_W3, P_c, P_cAnti, 461, check)
    call createCurrent(P_W3, P_cAnti, P_c, 462, check)
    call createCurrent(P_t, P_W3, P_tAnti, 463, check)
    call createCurrent(P_tAnti, P_t, P_W3, 464, check)
    call createCurrent(P_tAnti, P_W3, P_t, 465, check)
    call createCurrent(P_W3, P_t, P_tAnti, 466, check)
    call createCurrent(P_W3, P_tAnti, P_t, 467, check)
    call createCurrent(P_nu_eAnti, P_nu_e, P_W3, 468, check)
    call createCurrent(P_nu_eAnti, P_W3, P_nu_e, 469, check)
    call createCurrent(P_nu_e, P_W3, P_nu_eAnti, 470, check)
    call createCurrent(P_W3, P_nu_eAnti, P_nu_e, 471, check)
    call createCurrent(P_W3, P_nu_e, P_nu_eAnti, 472, check)
    call createCurrent(P_nu_muAnti, P_W3, P_nu_mu, 473, check)
    call createCurrent(P_nu_muAnti, P_nu_mu, P_W3, 474, check)
    call createCurrent(P_W3, P_nu_muAnti, P_nu_mu, 475, check)
    call createCurrent(P_W3, P_nu_mu, P_nu_muAnti, 476, check)
    call createCurrent(P_nu_mu, P_W3, P_nu_muAnti, 477, check)
    call createCurrent(P_nu_tauAnti, P_nu_tau, P_W3, 478, check)
    call createCurrent(P_nu_tauAnti, P_W3, P_nu_tau, 479, check)
    call createCurrent(P_nu_tau, P_W3, P_nu_tauAnti, 480, check)
    call createCurrent(P_W3, P_nu_tauAnti, P_nu_tau, 481, check)
    call createCurrent(P_W3, P_nu_tau, P_nu_tauAnti, 482, check)
    call createCurrent(P_WMinus, P_dAnti, P_u, 483, check)
    call createCurrent(P_WMinus, P_u, P_dAnti, 484, check)
    call createCurrent(P_dAnti, P_WMinus, P_u, 485, check)
    call createCurrent(P_dAnti, P_u, P_WMinus, 486, check)
    call createCurrent(P_u, P_WMinus, P_dAnti, 487, check)
    call createCurrent(P_sAnti, P_WMinus, P_c, 488, check)
    call createCurrent(P_sAnti, P_c, P_WMinus, 489, check)
    call createCurrent(P_c, P_WMinus, P_sAnti, 490, check)
    call createCurrent(P_WMinus, P_sAnti, P_c, 491, check)
    call createCurrent(P_WMinus, P_c, P_sAnti, 492, check)
    call createCurrent(P_WMinus, P_t, P_bAnti, 493, check)
    call createCurrent(P_WMinus, P_bAnti, P_t, 494, check)
    call createCurrent(P_t, P_WMinus, P_bAnti, 495, check)
    call createCurrent(P_bAnti, P_WMinus, P_t, 496, check)
    call createCurrent(P_bAnti, P_t, P_WMinus, 497, check)
    call createCurrent(P_WMinus, P_nu_e, P_ePlus, 498, check)
    call createCurrent(P_WMinus, P_ePlus, P_nu_e, 499, check)
    call createCurrent(P_nu_e, P_WMinus, P_ePlus, 500, check)
    call createCurrent(P_ePlus, P_WMinus, P_nu_e, 501, check)
    call createCurrent(P_ePlus, P_nu_e, P_WMinus, 502, check)
    call createCurrent(P_WMinus, P_muPlus, P_nu_mu, 503, check)
    call createCurrent(P_WMinus, P_nu_mu, P_muPlus, 504, check)
    call createCurrent(P_muPlus, P_WMinus, P_nu_mu, 505, check)
    call createCurrent(P_muPlus, P_nu_mu, P_WMinus, 506, check)
    call createCurrent(P_nu_mu, P_WMinus, P_muPlus, 507, check)
    call createCurrent(P_WMinus, P_tauPlus, P_nu_tau, 508, check)
    call createCurrent(P_WMinus, P_nu_tau, P_tauPlus, 509, check)
    call createCurrent(P_tauPlus, P_WMinus, P_nu_tau, 510, check)
    call createCurrent(P_tauPlus, P_nu_tau, P_WMinus, 511, check)
    call createCurrent(P_nu_tau, P_WMinus, P_tauPlus, 512, check)
    call createCurrent(P_ghW3Anti, P_WPlus, P_ghWm, 513, check)
    call createCurrent(P_ghWm, P_ghW3Anti, P_WPlus, 514, check)
    call createCurrent(P_ghWm, P_WPlus, P_ghW3Anti, 515, check)
    call createCurrent(P_WPlus, P_ghW3Anti, P_ghWm, 516, check)
    call createCurrent(P_WPlus, P_ghWm, P_ghW3Anti, 517, check)
    call createCurrent(P_ghW3Anti, P_WMinus, P_ghWp, 518, check)
    call createCurrent(P_ghWp, P_WMinus, P_ghW3Anti, 519, check)
    call createCurrent(P_ghWp, P_ghW3Anti, P_WMinus, 520, check)
    call createCurrent(P_WMinus, P_ghW3Anti, P_ghWp, 521, check)
    call createCurrent(P_WMinus, P_ghWp, P_ghW3Anti, 522, check)
    call createCurrent(P_WMinus, P_ghWmAnti, P_ghW3, 523, check)
    call createCurrent(P_WMinus, P_ghW3, P_ghWmAnti, 524, check)
    call createCurrent(P_ghWmAnti, P_WMinus, P_ghW3, 525, check)
    call createCurrent(P_ghW3, P_WMinus, P_ghWmAnti, 526, check)
    call createCurrent(P_ghW3, P_ghWmAnti, P_WMinus, 527, check)
    call createCurrent(P_ghWm, P_ghWmAnti, P_W3, 528, check)
    call createCurrent(P_ghWm, P_W3, P_ghWmAnti, 529, check)
    call createCurrent(P_ghWmAnti, P_W3, P_ghWm, 530, check)
    call createCurrent(P_W3, P_ghWm, P_ghWmAnti, 531, check)
    call createCurrent(P_W3, P_ghWmAnti, P_ghWm, 532, check)
    call createCurrent(P_WPlus, P_ghW3, P_ghWpAnti, 533, check)
    call createCurrent(P_WPlus, P_ghWpAnti, P_ghW3, 534, check)
    call createCurrent(P_ghW3, P_WPlus, P_ghWpAnti, 535, check)
    call createCurrent(P_ghW3, P_ghWpAnti, P_WPlus, 536, check)
    call createCurrent(P_ghWpAnti, P_WPlus, P_ghW3, 537, check)
    call createCurrent(P_ghWp, P_ghWpAnti, P_W3, 538, check)
    call createCurrent(P_ghWp, P_W3, P_ghWpAnti, 539, check)
    call createCurrent(P_ghWpAnti, P_W3, P_ghWp, 540, check)
    call createCurrent(P_W3, P_ghWp, P_ghWpAnti, 541, check)
    call createCurrent(P_W3, P_ghWpAnti, P_ghWp, 542, check)
    call createCurrent(P_ghGAnti, P_g, P_ghG, 543, check)
    call createCurrent(P_g, P_ghGAnti, P_ghG, 544, check)
    call createCurrent(P_g, P_ghG, P_ghGAnti, 545, check)
    call createCurrent(P_ghG, P_ghGAnti, P_g, 546, check)
    call createCurrent(P_ghG, P_g, P_ghGAnti, 547, check)
    call createCurrent(P_Phi1, P_Phi1Anti, 548, check)
    call createCurrent(P_Phi2, P_Phi2Anti, 549, check)
    call createCurrent(P_nu_e, P_nu_eAnti, 550, check)
    call createCurrent(P_nu_mu, P_nu_muAnti, 551, check)
    call createCurrent(P_nu_tau, P_nu_tauAnti, 552, check)
    call createCurrent(P_eMinus, P_ePlus, 553, check)
    call createCurrent(P_muMinus, P_muPlus, 554, check)
    call createCurrent(P_tauMinus, P_tauPlus, 555, check)
    call createCurrent(P_u, P_uAnti, 556, check)
    call createCurrent(P_c, P_cAnti, 557, check)
    call createCurrent(P_t, P_tAnti, 558, check)
    call createCurrent(P_d, P_dAnti, 559, check)
    call createCurrent(P_s, P_sAnti, 560, check)
    call createCurrent(P_b, P_bAnti, 561, check)
    call createCurrent(P_B0, P_B0, 562, check)
    call createCurrent(P_WMinus, P_WPlus, 563, check)
    call createCurrent(P_W3, P_W3, 564, check)
    call createCurrent(P_g, P_g, 565, check)
    call createCurrent(P_Phi1Anti, P_Phi1, 566, check)
    call createCurrent(P_Phi2Anti, P_Phi2, 567, check)
    call createCurrent(P_nu_eAnti, P_nu_e, 568, check)
    call createCurrent(P_nu_muAnti, P_nu_mu, 569, check)
    call createCurrent(P_nu_tauAnti, P_nu_tau, 570, check)
    call createCurrent(P_ePlus, P_eMinus, 571, check)
    call createCurrent(P_muPlus, P_muMinus, 572, check)
    call createCurrent(P_tauPlus, P_tauMinus, 573, check)
    call createCurrent(P_uAnti, P_u, 574, check)
    call createCurrent(P_cAnti, P_c, 575, check)
    call createCurrent(P_tAnti, P_t, 576, check)
    call createCurrent(P_dAnti, P_d, 577, check)
    call createCurrent(P_sAnti, P_s, 578, check)
    call createCurrent(P_bAnti, P_b, 579, check)
    call createCurrent(P_WPlus, P_WMinus, 580, check)
    call createCurrent(P_Phi1Anti, P_Phi1Anti, P_Phi1, P_Phi1, 581, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_Phi1Anti, P_Phi1, 582, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_Phi1, P_Phi1Anti, 583, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_Phi1Anti, P_Phi1, 584, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_Phi1, P_Phi1Anti, 585, check)
    call createCurrent(P_Phi1, P_Phi1, P_Phi1Anti, P_Phi1Anti, 586, check)
    call createCurrent(P_Phi1Anti, P_Phi2, P_Phi1, P_Phi2Anti, 587, check)
    call createCurrent(P_Phi1Anti, P_Phi2, P_Phi2Anti, P_Phi1, 588, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_Phi2, P_Phi2Anti, 589, check)
    call createCurrent(P_Phi1Anti, P_Phi1, P_Phi2Anti, P_Phi2, 590, check)
    call createCurrent(P_Phi1Anti, P_Phi2Anti, P_Phi2, P_Phi1, 591, check)
    call createCurrent(P_Phi1Anti, P_Phi2Anti, P_Phi1, P_Phi2, 592, check)
    call createCurrent(P_Phi2, P_Phi1Anti, P_Phi1, P_Phi2Anti, 593, check)
    call createCurrent(P_Phi2, P_Phi1Anti, P_Phi2Anti, P_Phi1, 594, check)
    call createCurrent(P_Phi2, P_Phi1, P_Phi1Anti, P_Phi2Anti, 595, check)
    call createCurrent(P_Phi2, P_Phi1, P_Phi2Anti, P_Phi1Anti, 596, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_Phi1Anti, P_Phi1, 597, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_Phi1, P_Phi1Anti, 598, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_Phi2, P_Phi2Anti, 599, check)
    call createCurrent(P_Phi1, P_Phi1Anti, P_Phi2Anti, P_Phi2, 600, check)
    call createCurrent(P_Phi1, P_Phi2, P_Phi1Anti, P_Phi2Anti, 601, check)
    call createCurrent(P_Phi1, P_Phi2, P_Phi2Anti, P_Phi1Anti, 602, check)
    call createCurrent(P_Phi1, P_Phi2Anti, P_Phi1Anti, P_Phi2, 603, check)
    call createCurrent(P_Phi1, P_Phi2Anti, P_Phi2, P_Phi1Anti, 604, check)
    call createCurrent(P_Phi2Anti, P_Phi1Anti, P_Phi2, P_Phi1, 605, check)
    call createCurrent(P_Phi2Anti, P_Phi1Anti, P_Phi1, P_Phi2, 606, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_Phi1Anti, P_Phi1, 607, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_Phi1, P_Phi1Anti, 608, check)
    call createCurrent(P_Phi2Anti, P_Phi1, P_Phi1Anti, P_Phi2, 609, check)
    call createCurrent(P_Phi2Anti, P_Phi1, P_Phi2, P_Phi1Anti, 610, check)
    call createCurrent(P_Phi2, P_Phi2, P_Phi2Anti, P_Phi2Anti, 611, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_Phi2, P_Phi2Anti, 612, check)
    call createCurrent(P_Phi2, P_Phi2Anti, P_Phi2Anti, P_Phi2, 613, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_Phi2, P_Phi2Anti, 614, check)
    call createCurrent(P_Phi2Anti, P_Phi2, P_Phi2Anti, P_Phi2, 615, check)
    call createCurrent(P_Phi2Anti, P_Phi2Anti, P_Phi2, P_Phi2, 616, check)
    call createCurrent(P_WPlus, P_B0, P_B0, P_WMinus, 617, check)
    call createCurrent(P_WPlus, P_B0, P_WMinus, P_B0, 618, check)
    call createCurrent(P_WPlus, P_WMinus, P_B0, P_B0, 619, check)
    call createCurrent(P_B0, P_WPlus, P_B0, P_WMinus, 620, check)
    call createCurrent(P_B0, P_WPlus, P_WMinus, P_B0, 621, check)
    call createCurrent(P_B0, P_B0, P_WPlus, P_WMinus, 622, check)
    call createCurrent(P_B0, P_B0, P_WMinus, P_WPlus, 623, check)
    call createCurrent(P_B0, P_WMinus, P_WPlus, P_B0, 624, check)
    call createCurrent(P_B0, P_WMinus, P_B0, P_WPlus, 625, check)
    call createCurrent(P_WMinus, P_WPlus, P_B0, P_B0, 626, check)
    call createCurrent(P_WMinus, P_B0, P_WPlus, P_B0, 627, check)
    call createCurrent(P_WMinus, P_B0, P_B0, P_WPlus, 628, check)
    call createCurrent(P_W3, P_W3, P_B0, P_B0, 629, check)
    call createCurrent(P_W3, P_B0, P_W3, P_B0, 630, check)
    call createCurrent(P_W3, P_B0, P_B0, P_W3, 631, check)
    call createCurrent(P_B0, P_W3, P_W3, P_B0, 632, check)
    call createCurrent(P_B0, P_W3, P_B0, P_W3, 633, check)
    call createCurrent(P_B0, P_B0, P_W3, P_W3, 634, check)
    call createCurrent(P_WPlus, P_g, P_g, P_WMinus, 635, check)
    call createCurrent(P_WPlus, P_g, P_WMinus, P_g, 636, check)
    call createCurrent(P_WPlus, P_WMinus, P_g, P_g, 637, check)
    call createCurrent(P_WMinus, P_g, P_g, P_WPlus, 638, check)
    call createCurrent(P_WMinus, P_g, P_WPlus, P_g, 639, check)
    call createCurrent(P_WMinus, P_WPlus, P_g, P_g, 640, check)
    call createCurrent(P_g, P_g, P_WPlus, P_WMinus, 641, check)
    call createCurrent(P_g, P_g, P_WMinus, P_WPlus, 642, check)
    call createCurrent(P_g, P_WPlus, P_g, P_WMinus, 643, check)
    call createCurrent(P_g, P_WPlus, P_WMinus, P_g, 644, check)
    call createCurrent(P_g, P_WMinus, P_g, P_WPlus, 645, check)
    call createCurrent(P_g, P_WMinus, P_WPlus, P_g, 646, check)
    call createCurrent(P_W3, P_W3, P_W3, P_W3, 647, check)
    call createCurrent(P_B0, P_B0, P_B0, P_B0, 648, check)
    call createCurrent(P_g, P_g, P_W3, P_W3, 649, check)
    call createCurrent(P_g, P_W3, P_g, P_W3, 650, check)
    call createCurrent(P_g, P_W3, P_W3, P_g, 651, check)
    call createCurrent(P_W3, P_g, P_g, P_W3, 652, check)
    call createCurrent(P_W3, P_g, P_W3, P_g, 653, check)
    call createCurrent(P_W3, P_W3, P_g, P_g, 654, check)
    call createCurrent(P_g, P_g, P_B0, P_B0, 655, check)
    call createCurrent(P_g, P_B0, P_g, P_B0, 656, check)
    call createCurrent(P_g, P_B0, P_B0, P_g, 657, check)
    call createCurrent(P_B0, P_g, P_g, P_B0, 658, check)
    call createCurrent(P_B0, P_g, P_B0, P_g, 659, check)
    call createCurrent(P_B0, P_B0, P_g, P_g, 660, check)
    call createCurrent(P_g, P_g, P_g, P_B0, 661, check)
    call createCurrent(P_g, P_g, P_B0, P_g, 662, check)
    call createCurrent(P_g, P_B0, P_g, P_g, 663, check)
    call createCurrent(P_B0, P_g, P_g, P_g, 664, check)
  end subroutine fill_current_1
end module currents_info1
