!******************************************************************************!
!                                                                              !
!    fill_ctparameters.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctparameters.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctparameters
  use class_ctparameters
  use modelintegrals, only: set_modelintegrals
  use ctparameter0, only: set_ctparameter0
  use ctparameter1, only: set_ctparameter1
  use ctparameter2, only: set_ctparameter2
  use ctparameter3, only: set_ctparameter3
  use ctparameter4, only: set_ctparameter4
  use ctparameter5, only: set_ctparameter5
  use ctparameter6, only: set_ctparameter6
  use ctparameter7, only: set_ctparameter7
  use ctparameter8, only: set_ctparameter8
  use ctparameter9, only: set_ctparameter9
  use ctparameter10, only: set_ctparameter10
  use ctparameter11, only: set_ctparameter11
  use ctparameter12, only: set_ctparameter12
  use ctparameter13, only: set_ctparameter13
  use ctparameter14, only: set_ctparameter14
  use ctparameter15, only: set_ctparameter15
  use ctparameter16, only: set_ctparameter16
  use ctparameter17, only: set_ctparameter17
  use ctparameter18, only: set_ctparameter18
  use ctparameter19, only: set_ctparameter19
  use ctparameter20, only: set_ctparameter20
  use ctparameter21, only: set_ctparameter21
  use ctparameter22, only: set_ctparameter22
  use ctparameter23, only: set_ctparameter23
  use ctparameter24, only: set_ctparameter24
  use ctparameter25, only: set_ctparameter25
  use ctparameter26, only: set_ctparameter26
  use ctparameter27, only: set_ctparameter27
  use ctparameter28, only: set_ctparameter28
  use ctparameter29, only: set_ctparameter29
  use ctparameter30, only: set_ctparameter30
  use ctparameter31, only: set_ctparameter31
  use ctparameter32, only: set_ctparameter32
  use ctparameter33, only: set_ctparameter33
  use ctparameter34, only: set_ctparameter34
  use ctparameter35, only: set_ctparameter35
  use ctparameter36, only: set_ctparameter36
  use ctparameter37, only: set_ctparameter37
  use ctparameter38, only: set_ctparameter38
  use ctparameter39, only: set_ctparameter39
  use ctparameter40, only: set_ctparameter40
  use ctparameter41, only: set_ctparameter41
  use ctparameter42, only: set_ctparameter42
  use ctparameter43, only: set_ctparameter43
  use ctparameter44, only: set_ctparameter44
  use ctparameter45, only: set_ctparameter45
  use ctparameter46, only: set_ctparameter46
  use ctparameter47, only: set_ctparameter47
  use ctparameter48, only: set_ctparameter48
  use ctparameter49, only: set_ctparameter49
  use ctparameter50, only: set_ctparameter50
  use ctparameter51, only: set_ctparameter51
  use ctparameter52, only: set_ctparameter52
  use ctparameter53, only: set_ctparameter53
  use ctparameter54, only: set_ctparameter54
  use ctparameter55, only: set_ctparameter55
  use ctparameter56, only: set_ctparameter56
  use ctparameter57, only: set_ctparameter57
  use ctparameter58, only: set_ctparameter58
  use ctparameter59, only: set_ctparameter59
  use ctparameter60, only: set_ctparameter60
  use ctparameter61, only: set_ctparameter61
  use ctparameter62, only: set_ctparameter62
  use ctparameter63, only: set_ctparameter63
  use ctparameter64, only: set_ctparameter64
  use ctparameter65, only: set_ctparameter65
  use ctparameter66, only: set_ctparameter66
  use derived_ctparameter, only: set_derived_ctparameter
  contains

  subroutine set_renoscheme_mdl(ctparam,renoscheme)
    use input_mdl, only: warning_mdl
    character(*), intent(in) :: ctparam
    character(*), intent(in) :: renoscheme

    select case(ctparam)
    case('dZeMinusR_GC12')
      select case(renoscheme)
      case('onshell')
        dZeMinusR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZeMinusL_GC12')
      select case(renoscheme)
      case('onshell')
        dZeMinusL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZeMinusL_GC22')
      select case(renoscheme)
      case('onshell')
        dZeMinusL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZmuMinusR_GC12')
      select case(renoscheme)
      case('onshell')
        dZmuMinusR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZmuMinusL_GC22')
      select case(renoscheme)
      case('onshell')
        dZmuMinusL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZmuMinusL_GC12')
      select case(renoscheme)
      case('onshell')
        dZmuMinusL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtauMinusL_GC12')
      select case(renoscheme)
      case('onshell')
        dZtauMinusL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtauMinusL_GC22')
      select case(renoscheme)
      case('onshell')
        dZtauMinusL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtauMinusR_GC12')
      select case(renoscheme)
      case('onshell')
        dZtauMinusR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_eL_GC22')
      select case(renoscheme)
      case('onshell')
        dZnu_eL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_eL_GC12')
      select case(renoscheme)
      case('onshell')
        dZnu_eL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_muL_GC12')
      select case(renoscheme)
      case('onshell')
        dZnu_muL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_muL_GC22')
      select case(renoscheme)
      case('onshell')
        dZnu_muL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_tauL_GC12')
      select case(renoscheme)
      case('onshell')
        dZnu_tauL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZnu_tauL_GC22')
      select case(renoscheme)
      case('onshell')
        dZnu_tauL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZW3_GC22')
      select case(renoscheme)
      case('onshell')
        dZW3_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZB0_GC12')
      select case(renoscheme)
      case('onshell')
        dZB0_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZWMinus_GC22')
      select case(renoscheme)
      case('onshell')
        dZWMinus_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZPhi1_GC12')
      select case(renoscheme)
      case('onshell')
        dZPhi1_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZPhi1_GC22')
      select case(renoscheme)
      case('onshell')
        dZPhi1_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZPhi2_GC12')
      select case(renoscheme)
      case('onshell')
        dZPhi2_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZPhi2_GC22')
      select case(renoscheme)
      case('onshell')
        dZPhi2_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZg_QCD2')
      select case(renoscheme)
      case('onshell')
        dZg_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZuL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuL_GC22')
      select case(renoscheme)
      case('onshell')
        dZuL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuL_GC12')
      select case(renoscheme)
      case('onshell')
        dZuL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZuR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuR_GC12')
      select case(renoscheme)
      case('onshell')
        dZuR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZuR_GC22')
      select case(renoscheme)
      case('onshell')
        dZuR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdR_GC12')
      select case(renoscheme)
      case('onshell')
        dZdR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdR_GC22')
      select case(renoscheme)
      case('onshell')
        dZdR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZdR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdL_GC22')
      select case(renoscheme)
      case('onshell')
        dZdL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdL_GC12')
      select case(renoscheme)
      case('onshell')
        dZdL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZdL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZdL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZcR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcR_GC22')
      select case(renoscheme)
      case('onshell')
        dZcR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcR_GC12')
      select case(renoscheme)
      case('onshell')
        dZcR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZcL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcL_GC22')
      select case(renoscheme)
      case('onshell')
        dZcL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZcL_GC12')
      select case(renoscheme)
      case('onshell')
        dZcL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZsR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsR_GC12')
      select case(renoscheme)
      case('onshell')
        dZsR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsR_GC22')
      select case(renoscheme)
      case('onshell')
        dZsR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsL_GC22')
      select case(renoscheme)
      case('onshell')
        dZsL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsL_GC12')
      select case(renoscheme)
      case('onshell')
        dZsL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZsL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZsL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZbR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbR_GC22')
      select case(renoscheme)
      case('onshell')
        dZbR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbR_GC12')
      select case(renoscheme)
      case('onshell')
        dZbR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbL_GC22')
      select case(renoscheme)
      case('onshell')
        dZbL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZbL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZbL_GC12')
      select case(renoscheme)
      case('onshell')
        dZbL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtR_GC22')
      select case(renoscheme)
      case('onshell')
        dZtR_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtR_GC12')
      select case(renoscheme)
      case('onshell')
        dZtR_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtR_QCD2')
      select case(renoscheme)
      case('onshell')
        dZtR_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtL_GC12')
      select case(renoscheme)
      case('onshell')
        dZtL_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtL_QCD2')
      select case(renoscheme)
      case('onshell')
        dZtL_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZtL_GC22')
      select case(renoscheme)
      case('onshell')
        dZtL_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZeMinusL_MS_GC12')
      select case(renoscheme)
      case('MS')
        dZeMinusL_MS_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZeMinusL_MS_GC22')
      select case(renoscheme)
      case('MS')
        dZeMinusL_MS_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZeMinusR_MS_GC12')
      select case(renoscheme)
      case('MS')
        dZeMinusR_MS_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZB0_MS_GC12')
      select case(renoscheme)
      case('MS')
        dZB0_MS_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZg1_GC12')
      select case(renoscheme)
      case('MS')
        dZg1_GC12_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZW3_MS_GC22')
      select case(renoscheme)
      case('MS')
        dZW3_MS_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZg2_GC22')
      select case(renoscheme)
      case('MS')
        dZg2_GC22_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case('dZgs_QCD2')
      select case(renoscheme)
      case('Nf6')
        dZgs_QCD2_scheme = 0
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='set_renoscheme_mdl')
      end select 
    case default
      call warning_mdl('No renoscheme available for '// trim(ctparam) // '.',  &
      where='set_renoscheme_mdl')
    end select 
  end subroutine set_renoscheme_mdl

  function get_renoscheme_mdl(ctparam)
    use input_mdl, only: warning_mdl
    character(*), intent(in) :: ctparam
    character(len=100) :: get_renoscheme_mdl

    select case(ctparam)
    case('dZeMinusR_GC12')
      select case(dZeMinusR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZeMinusL_GC12')
      select case(dZeMinusL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZeMinusL_GC22')
      select case(dZeMinusL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZmuMinusR_GC12')
      select case(dZmuMinusR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZmuMinusL_GC22')
      select case(dZmuMinusL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZmuMinusL_GC12')
      select case(dZmuMinusL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtauMinusL_GC12')
      select case(dZtauMinusL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtauMinusL_GC22')
      select case(dZtauMinusL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtauMinusR_GC12')
      select case(dZtauMinusR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_eL_GC22')
      select case(dZnu_eL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_eL_GC12')
      select case(dZnu_eL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_muL_GC12')
      select case(dZnu_muL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_muL_GC22')
      select case(dZnu_muL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_tauL_GC12')
      select case(dZnu_tauL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZnu_tauL_GC22')
      select case(dZnu_tauL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZW3_GC22')
      select case(dZW3_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZB0_GC12')
      select case(dZB0_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZWMinus_GC22')
      select case(dZWMinus_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZPhi1_GC12')
      select case(dZPhi1_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZPhi1_GC22')
      select case(dZPhi1_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZPhi2_GC12')
      select case(dZPhi2_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZPhi2_GC22')
      select case(dZPhi2_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZg_QCD2')
      select case(dZg_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuL_QCD2')
      select case(dZuL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuL_GC22')
      select case(dZuL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuL_GC12')
      select case(dZuL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuR_QCD2')
      select case(dZuR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuR_GC12')
      select case(dZuR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZuR_GC22')
      select case(dZuR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdR_GC12')
      select case(dZdR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdR_GC22')
      select case(dZdR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdR_QCD2')
      select case(dZdR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdL_GC22')
      select case(dZdL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdL_GC12')
      select case(dZdL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZdL_QCD2')
      select case(dZdL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcR_QCD2')
      select case(dZcR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcR_GC22')
      select case(dZcR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcR_GC12')
      select case(dZcR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcL_QCD2')
      select case(dZcL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcL_GC22')
      select case(dZcL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZcL_GC12')
      select case(dZcL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsR_QCD2')
      select case(dZsR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsR_GC12')
      select case(dZsR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsR_GC22')
      select case(dZsR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsL_GC22')
      select case(dZsL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsL_GC12')
      select case(dZsL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZsL_QCD2')
      select case(dZsL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbR_QCD2')
      select case(dZbR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbR_GC22')
      select case(dZbR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbR_GC12')
      select case(dZbR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbL_GC22')
      select case(dZbL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbL_QCD2')
      select case(dZbL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZbL_GC12')
      select case(dZbL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtR_GC22')
      select case(dZtR_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtR_GC12')
      select case(dZtR_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtR_QCD2')
      select case(dZtR_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtL_GC12')
      select case(dZtL_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtL_QCD2')
      select case(dZtL_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZtL_GC22')
      select case(dZtL_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "onshell"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZeMinusL_MS_GC12')
      select case(dZeMinusL_MS_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZeMinusL_MS_GC22')
      select case(dZeMinusL_MS_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZeMinusR_MS_GC12')
      select case(dZeMinusR_MS_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZB0_MS_GC12')
      select case(dZB0_MS_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZg1_GC12')
      select case(dZg1_GC12_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZW3_MS_GC22')
      select case(dZW3_MS_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZg2_GC22')
      select case(dZg2_GC22_scheme)
      case(0)
        get_renoscheme_mdl = "MS"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case('dZgs_QCD2')
      select case(dZgs_QCD2_scheme)
      case(0)
        get_renoscheme_mdl = "Nf6"
      case default
        call warning_mdl('Invalid renoscheme for '// trim(ctparam) // '.',     &
        where='get_renoscheme_mdl')
        get_renoscheme_mdl = "NONE"
      end select 
    case default
      call warning_mdl('No renoschemes for '// trim(ctparam) // '.', where     &
      ='get_renoscheme_mdl')
      get_renoscheme_mdl = "NONE"
    end select 
  end function get_renoscheme_mdl

  subroutine print_renoschemes_mdl()
    use input_mdl, only: nx
    character(len=100) :: active_renoscheme
    character(len=14) :: fmt = '(4x,a15,a30)'

    write(nx,*) 'Renormalization scheme choice:'
!   dZg1_GC12, schemes: MS
    active_renoscheme = get_renoscheme_mdl("dZg1_GC12")
    write(nx,fmt) adjustl('dZg1_GC12: '), trim(active_renoscheme)
!   dZg2_GC22, schemes: MS
    active_renoscheme = get_renoscheme_mdl("dZg2_GC22")
    write(nx,fmt) adjustl('dZg2_GC22: '), trim(active_renoscheme)
!   dZgs_QCD2, schemes: Nf6
    active_renoscheme = get_renoscheme_mdl("dZgs_QCD2")
    write(nx,fmt) adjustl('dZgs_QCD2: '), trim(active_renoscheme)
    write(nx,'(1x,75("-"))')
  end subroutine print_renoschemes_mdl

  subroutine print_counterterms_mdl()
    use input_mdl, only: nx
    character(len=26) :: fmtc = '(4x,a17,es23.16,x,es23.16)'
    write(nx,'(1x,75("-"))')
    write(nx,*) 'Counterterm parameters'
    write(nx,'(1x,75("-"))')
    write(nx,*) 'Particle counterterm parameter:'
    write(nx,*) 'Particle: B0'
    write(nx,fmtc) 'dZB0_GC12 =', dZB0_GC12
    write(nx,*) 'Particle: W+'
    write(nx,fmtc) 'dZWMinus_GC22 =', dZWMinus_GC22
    write(nx,*) 'Particle: W3'
    write(nx,fmtc) 'dZW3_GC22 =', dZW3_GC22
    write(nx,*) 'Particle: g'
    write(nx,fmtc) 'dZg_QCD2 =', dZg_QCD2
    write(nx,*) 'Particle: nu_e'
    write(nx,fmtc) 'dZnu_eL_GC12 =', dZnu_eL_GC12
    write(nx,fmtc) 'dZnu_eL_GC22 =', dZnu_eL_GC22
    write(nx,*) 'Particle: nu_mu'
    write(nx,fmtc) 'dZnu_muL_GC12 =', dZnu_muL_GC12
    write(nx,fmtc) 'dZnu_muL_GC22 =', dZnu_muL_GC22
    write(nx,*) 'Particle: nu_tau'
    write(nx,fmtc) 'dZnu_tauL_GC12 =', dZnu_tauL_GC12
    write(nx,fmtc) 'dZnu_tauL_GC22 =', dZnu_tauL_GC22
    write(nx,*) 'Particle: e-'
    write(nx,fmtc) 'dZeMinusL_GC12 =', dZeMinusL_GC12
    write(nx,fmtc) 'dZeMinusL_GC22 =', dZeMinusL_GC22
    write(nx,fmtc) 'dZeMinusR_GC12 =', dZeMinusR_GC12
    write(nx,*) 'Particle: mu-'
    write(nx,fmtc) 'dZmuMinusL_GC12 =', dZmuMinusL_GC12
    write(nx,fmtc) 'dZmuMinusL_GC22 =', dZmuMinusL_GC22
    write(nx,fmtc) 'dZmuMinusR_GC12 =', dZmuMinusR_GC12
    write(nx,*) 'Particle: tau-'
    write(nx,fmtc) 'dZtauMinusL_GC12 =', dZtauMinusL_GC12
    write(nx,fmtc) 'dZtauMinusL_GC22 =', dZtauMinusL_GC22
    write(nx,fmtc) 'dZtauMinusR_GC12 =', dZtauMinusR_GC12
    write(nx,*) 'Particle: u'
    write(nx,fmtc) 'dZuR_GC12 =', dZuR_GC12
    write(nx,fmtc) 'dZuR_GC22 =', dZuR_GC22
    write(nx,fmtc) 'dZuR_QCD2 =', dZuR_QCD2
    write(nx,fmtc) 'dZuL_GC12 =', dZuL_GC12
    write(nx,fmtc) 'dZuL_GC22 =', dZuL_GC22
    write(nx,fmtc) 'dZuL_QCD2 =', dZuL_QCD2
    write(nx,*) 'Particle: c'
    write(nx,fmtc) 'dZcR_GC12 =', dZcR_GC12
    write(nx,fmtc) 'dZcR_GC22 =', dZcR_GC22
    write(nx,fmtc) 'dZcR_QCD2 =', dZcR_QCD2
    write(nx,fmtc) 'dZcL_GC12 =', dZcL_GC12
    write(nx,fmtc) 'dZcL_GC22 =', dZcL_GC22
    write(nx,fmtc) 'dZcL_QCD2 =', dZcL_QCD2
    write(nx,*) 'Particle: t'
    write(nx,fmtc) 'dZtR_GC12 =', dZtR_GC12
    write(nx,fmtc) 'dZtR_GC22 =', dZtR_GC22
    write(nx,fmtc) 'dZtR_QCD2 =', dZtR_QCD2
    write(nx,fmtc) 'dZtL_GC12 =', dZtL_GC12
    write(nx,fmtc) 'dZtL_GC22 =', dZtL_GC22
    write(nx,fmtc) 'dZtL_QCD2 =', dZtL_QCD2
    write(nx,*) 'Particle: d'
    write(nx,fmtc) 'dZdR_GC12 =', dZdR_GC12
    write(nx,fmtc) 'dZdR_GC22 =', dZdR_GC22
    write(nx,fmtc) 'dZdR_QCD2 =', dZdR_QCD2
    write(nx,fmtc) 'dZdL_GC12 =', dZdL_GC12
    write(nx,fmtc) 'dZdL_GC22 =', dZdL_GC22
    write(nx,fmtc) 'dZdL_QCD2 =', dZdL_QCD2
    write(nx,*) 'Particle: s'
    write(nx,fmtc) 'dZsL_GC12 =', dZsL_GC12
    write(nx,fmtc) 'dZsL_GC22 =', dZsL_GC22
    write(nx,fmtc) 'dZsL_QCD2 =', dZsL_QCD2
    write(nx,fmtc) 'dZsR_GC12 =', dZsR_GC12
    write(nx,fmtc) 'dZsR_GC22 =', dZsR_GC22
    write(nx,fmtc) 'dZsR_QCD2 =', dZsR_QCD2
    write(nx,*) 'Particle: b'
    write(nx,fmtc) 'dZbL_GC12 =', dZbL_GC12
    write(nx,fmtc) 'dZbL_GC22 =', dZbL_GC22
    write(nx,fmtc) 'dZbL_QCD2 =', dZbL_QCD2
    write(nx,fmtc) 'dZbR_GC12 =', dZbR_GC12
    write(nx,fmtc) 'dZbR_GC22 =', dZbR_GC22
    write(nx,fmtc) 'dZbR_QCD2 =', dZbR_QCD2
    write(nx,*) 'Particle: Phi1'
    write(nx,fmtc) 'dZPhi1_GC12 =', dZPhi1_GC12
    write(nx,fmtc) 'dZPhi1_GC22 =', dZPhi1_GC22
    write(nx,*) 'Particle: Phi2'
    write(nx,fmtc) 'dZPhi2_GC12 =', dZPhi2_GC12
    write(nx,fmtc) 'dZPhi2_GC22 =', dZPhi2_GC22
    write(nx,'(1x,75("-"))')
    write(nx,*) 'Coupling counterterm parameter:'
    write(nx,fmtc) 'dZg1_GC12 =', dZg1_GC12
    write(nx,fmtc) 'dZg2_GC22 =', dZg2_GC22
    write(nx,fmtc) 'dZgs_QCD2 =', dZgs_QCD2
  end subroutine print_counterterms_mdl

  subroutine set_light_particles_mdl()
    use class_particles
    use input_mdl, only: nx, print_regularization_scheme
    if (print_regularization_scheme) then
      write(nx,'(1x,75("-"))')
      write(nx,*) 'Light fermions renormalization scheme choice:'
    end if 
    if (print_regularization_scheme) write(nx,'(1x,75("-"))')
  end subroutine set_light_particles_mdl

  subroutine init_CTparameters_mdl(reset_collier)
    logical, intent(in) :: reset_collier
    call set_light_particles_mdl
    call set_modelintegrals(reset_collier)
    call set_ctparameter0
    call set_ctparameter1
    call set_ctparameter2
    call set_ctparameter3
    call set_ctparameter4
    call set_ctparameter5
    call set_ctparameter6
    call set_ctparameter7
    call set_ctparameter8
    call set_ctparameter9
    call set_ctparameter10
    call set_ctparameter11
    call set_ctparameter12
    call set_ctparameter13
    call set_ctparameter14
    call set_ctparameter15
    call set_ctparameter16
    call set_ctparameter17
    call set_ctparameter18
    call set_ctparameter19
    call set_ctparameter20
    call set_ctparameter21
    call set_ctparameter22
    call set_ctparameter23
    call set_ctparameter24
    call set_ctparameter25
    call set_ctparameter26
    call set_ctparameter27
    call set_ctparameter28
    call set_ctparameter29
    call set_ctparameter30
    call set_ctparameter31
    call set_ctparameter32
    call set_ctparameter33
    call set_ctparameter34
    call set_ctparameter35
    call set_ctparameter36
    call set_ctparameter37
    call set_ctparameter38
    call set_ctparameter39
    call set_ctparameter40
    call set_ctparameter41
    call set_ctparameter42
    call set_ctparameter43
    call set_ctparameter44
    call set_ctparameter45
    call set_ctparameter46
    call set_ctparameter47
    call set_ctparameter48
    call set_ctparameter49
    call set_ctparameter50
    call set_ctparameter51
    call set_ctparameter52
    call set_ctparameter53
    call set_ctparameter54
    call set_ctparameter55
    call set_ctparameter56
    call set_ctparameter57
    call set_ctparameter58
    call set_ctparameter59
    call set_ctparameter60
    call set_ctparameter61
    call set_ctparameter62
    call set_ctparameter63
    call set_ctparameter64
    call set_ctparameter65
    call set_ctparameter66
    call set_derived_ctparameter
  end subroutine init_CTparameters_mdl
end module fill_ctparameters
