!******************************************************************************!
!                                                                              !
!    tcFaF.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaF.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang, S. Rode                    |            !
!        | `---' | UFO date: 06/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-08-02 21:15             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16
  contains
    subroutine treeFaF(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaF0)
!       GammaM(-1,1,2)*P(-1,2)*c0
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = P1(2)*cima
      x1 = P1(0) - P1(3)
      x2 = pl(0)*w1(0)
      x3 = pl(3)*w1(1)
      x4 = w1(1)*x1
      x5 = w1(0)*(P1(0) + P1(3))
      x6 = co(0)*m
      wout(0) = -co(0)*(w1(0)*(P1(0)*pl(1) - P1(1)*pl(2) + P1(3)*pl(1) + pl(2)*&
                x0) + w1(1)*(P1(1)*pl(1) + pl(1)*x0 - pl(2)*x1))
      wout(1) = -co(0)*(P1(1)*(x2 - x3) + pl(0)*x4 - pl(3)*x5 - x0*(x2 + x3))
      wout(2) = -x6*(w1(1)*(P1(1) + x0) + x5)
      wout(3) = -x6*(P1(1)*w1(0) - w1(0)*x0 + x4)
    else
      x0 = P1(2)*cima
      wout(0) = 0
      wout(1) = 0
      wout(2) = -co(0)*(w1(0)*(P1(0) + P1(3)) + w1(1)*(P1(1) + x0))
      wout(3) = -co(0)*(P1(1)*w1(0) - w1(0)*x0 + w1(1)*(P1(0) - P1(3)))
    end if 
      case(FaF1)
!       GammaP(-1,1,2)*P(-1,2)*c0
!       GammaM(-1,1,2)*P(-1,2)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = P1(2)*cima
      x1 = P1(1)*pl(1)
      x2 = pl(1)*x0
      x3 = co(0)*m
      x4 = pl(0)*w1(0)
      x5 = pl(3)*w1(1)
      x6 = P1(0) + P1(3)
      x7 = w1(0)*x6
      x8 = co(0)*w1(2)
      x9 = co(0)*w1(3)
      x10 = P1(1) + x0
      x11 = co(1)*m
      wout(0) = -co(1)*(w1(0)*(P1(0)*pl(1) - P1(1)*pl(2) + P1(3)*pl(1) + pl(2)*&
                x0) + w1(1)*(-P1(0)*pl(2) + P1(3)*pl(2) + x1 + x2)) + x3*(-P1(0&
                )*w1(2) + P1(1)*w1(3) + P1(3)*w1(2) + w1(3)*x0)
      wout(1) = co(1)*(-P1(1)*(x4 - x5) - pl(0)*w1(1)*(P1(0) - P1(3)) + pl(3)* &
                x7 + x0*(x4 + x5)) - x3*(-P1(1)*w1(2) + w1(2)*x0 + w1(3)*x6)
      wout(2) = -x11*(w1(1)*x10 + x7) + x8*(-P1(0)*pl(0) + P1(3)*pl(0) + pl(2  &
                )*(P1(1) - x0)) + x9*(P1(1)*pl(0) + pl(0)*x0 - pl(2)*x6)
      wout(3) = -x11*(P1(0)*w1(1) + P1(1)*w1(0) - P1(3)*w1(1) - w1(0)*x0) - x8 &
                *(P1(0)*pl(3) - P1(3)*pl(3) - x1 + x2) - x9*(pl(1)*x6 - pl(3)* &
                x10)
    else
      x0 = P1(2)*cima
      x1 = P1(1) + x0
      x2 = P1(0) + P1(3)
      wout(0) = co(0)*(-P1(0)*w1(2) + P1(3)*w1(2) + w1(3)*x1)
      wout(1) = -co(0)*(-P1(1)*w1(2) + w1(2)*x0 + w1(3)*x2)
      wout(2) = -co(1)*(w1(0)*x2 + w1(1)*x1)
      wout(3) = -co(1)*(P1(1)*w1(0) - w1(0)*x0 + w1(1)*(P1(0) - P1(3)))
    end if 
      case(FaF2)
!       GammaP(-1,1,2)*P(-1,1)*c0
!       GammaM(-1,1,2)*P(-1,1)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = P1(1)*pl(2)
      x1 = P1(2)*cima
      x2 = pl(2)*x1
      x3 = P1(1)*pl(1)
      x4 = P1(3)*pl(2)
      x5 = P1(0)*pl(2)
      x6 = pl(1)*x1
      x7 = P1(3)*w1(2)
      x8 = P1(1) + x1
      x9 = P1(0)*w1(2)
      x10 = co(0)*m
      x11 = pl(0)*w1(0)
      x12 = pl(3)*w1(1)
      x13 = P1(0) + P1(3)
      x14 = w1(0)*x13
      x15 = pl(0)*w1(3)
      x16 = co(1)*m
      wout(0) = co(1)*w1(0)*(P1(0)*pl(1) + P1(3)*pl(1) - x0 + x2) + co(1)*w1(1 &
                )*(x3 + x4 - x5 + x6) - x10*(w1(3)*x8 + x7 - x9)
      wout(1) = co(1)*(P1(1)*(x11 - x12) + pl(0)*w1(1)*(P1(0) - P1(3)) - pl(3)*&
                x14 - x1*(x11 + x12)) + x10*(-P1(1)*w1(2) + w1(2)*x1 + w1(3)*  &
                x13)
      wout(2) = co(0)*(-P1(1)*x15 - pl(0)*x7 + pl(0)*x9 - w1(2)*x0 + w1(2)*x2  &
                 + w1(3)*x4 + w1(3)*x5 - x1*x15) + x16*(w1(1)*x8 + x14)
      wout(3) = co(0)*w1(2)*(P1(0)*pl(3) - P1(3)*pl(3) - x3 + x6) + co(0)*w1(3 &
                )*(pl(1)*x13 - pl(3)*x8) + x16*(P1(0)*w1(1) + P1(1)*w1(0) - P1(&
                3)*w1(1) - w1(0)*x1)
    else
      x0 = P1(2)*cima
      x1 = P1(1) + x0
      x2 = P1(0) + P1(3)
      wout(0) = -co(0)*(-P1(0)*w1(2) + P1(3)*w1(2) + w1(3)*x1)
      wout(1) = co(0)*(-P1(1)*w1(2) + w1(2)*x0 + w1(3)*x2)
      wout(2) = co(1)*(w1(0)*x2 + w1(1)*x1)
      wout(3) = co(1)*(P1(1)*w1(0) - w1(0)*x0 + w1(1)*(P1(0) - P1(3)))
    end if 
      case(FaF3)
!       GammaM(-1,1,2)*P(-1,1)*c0
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = P1(2)*cima
      x1 = P1(0) - P1(3)
      x2 = pl(0)*w1(0)
      x3 = pl(3)*w1(1)
      x4 = w1(1)*x1
      x5 = w1(0)*(P1(0) + P1(3))
      x6 = co(0)*m
      wout(0) = co(0)*(w1(0)*(P1(0)*pl(1) - P1(1)*pl(2) + P1(3)*pl(1) + pl(2)* &
                x0) + w1(1)*(P1(1)*pl(1) + pl(1)*x0 - pl(2)*x1))
      wout(1) = co(0)*(P1(1)*(x2 - x3) + pl(0)*x4 - pl(3)*x5 - x0*(x2 + x3))
      wout(2) = x6*(w1(1)*(P1(1) + x0) + x5)
      wout(3) = x6*(P1(1)*w1(0) - w1(0)*x0 + x4)
    else
      x0 = P1(2)*cima
      wout(0) = 0
      wout(1) = 0
      wout(2) = co(0)*(w1(0)*(P1(0) + P1(3)) + w1(1)*(P1(1) + x0))
      wout(3) = co(0)*(P1(1)*w1(0) - w1(0)*x0 + w1(1)*(P1(0) - P1(3)))
    end if 
      end select 
    end subroutine treeFaF
end module tcFaF
